

-- #######################################################
-- Var ini
-- #######################################################


--MalVars = {};
--now creating the table in the localization files before this file loads

--GLOBAL VARIABLES
--These are saved variables, so they need to be global
--## SavedVariables: Mclue, Mrpt
if (Mclue ~= nil) then
	if (Mclue == "") then
		MalVars.code = "99"
	else
		MalVars.code = Mclue
	end
else
	MalVars.code = "0"
end

--All other variables should be internal to Marauder
MalVars.version = "1.1";
MalVars.checkpoint = 0;
MalVars.currQuest = "";
MalVars.groupName = "";
MalVars.initializedParticipant = 0;
MalVars.sourceBaddie = "";
MalVars.offLogs = 0;
MalVars.sameLogs = 0;
MalVars.sameFacMsg = 0;
MalVars.isRes = 0;
MalVars.res = "";
MalVars.repeatPlay = 0;
MalVars.pGhost = ".";
MalVars.detail1 = nil;
MalVars.detail2 = nil;
MalVars.detail1set = 0;
MalVars.detail2set = 0;
MalVars.vote1 = 0;
MalVars.vote2 = 0;
MalVars.vote3 = 0;
MalVars.vote4 = 0;
MalVars.rune = 0;
MalVars.dal1 = 0;
MalVars.viol = 0;
MalVars.und = 0;
MalVars.ring = 0;
MalVars.partyBuns = 0;
MalVars.partyRats = 0;
MalVars.partyFrogs = 0;

--NPC demographics (changed Sedricck alliance for Spanish)
MalVars.npcAla = {hn = "Aladriaa", hr = "Forsaken", an = "Aladriea", ar = "Human",}
MalVars.npcSed = {hn = "Seddrik", hr = "Blood Elf", an = "Sedrick", ar = "Human",}
MalVars.npcCal = {hn = "Calliopia", hr = "Blood Elf", an = "Calliopi\195\164", ar = "Human",}
MalVars.npcIzu = {hn = "Izunai", hr = "Goblin", an = "Izuna", ar = "Gnome",}

--Initialize these in case the faction mapping function breaks, name calls won't be nil
MalVars.nAxe = "Axechew\195\171r";
MalVars.nAla = ".";
MalVars.nCal = ".";
MalVars.nIzu = ".";
MalVars.nSed = ".";
--for Spanish version, make the other NPC names variables too.
MalVars.nJin = "Jindall";
MalVars.nRhu = "Rhudoh";
MalVars.nAzu = "Azukk";
MalVars.nApr = "Apriloneil";
MalVars.nLib = "Bibliotecario Belleford";
MalVars.nJep = "Jepetto Jugarreta";
MalVars.nAmi = "Amisi Mirada Azur";
MalVars.nKar = "Karandonna";
--For the ranking window
MalVars.nLdr = "Rangos de Liderazgo"

--Map NPC names according to faction of player
local fg, fn = UnitFactionGroup("player");
if (fg == "Alliance") then
	--print("matched Alliance");
	MalVars.nAla = MalVars.npcAla.an;
	MalVars.nSed = MalVars.npcSed.an;
	MalVars.nCal = MalVars.npcCal.an;
	MalVars.nIzu = MalVars.npcIzu.hn; -- leave this, should be opposite cuz it's a foe
elseif (fg == "Horde") then
	--print("matched Horde");
	MalVars.nAla = MalVars.npcAla.hn;
	MalVars.nSed = MalVars.npcSed.hn;
	MalVars.nCal = MalVars.npcCal.hn;
	MalVars.nIzu = MalVars.npcIzu.an; -- leave this, should be opposite cuz it's a foe
end
if (GetUnitName("player") == MalVars.nAla) then
	MalVars.sameFacMsg = 1;
end


--Register to receive AddonMessages with desired prefixes
MalVars.p0 = RegisterAddonMessagePrefix("SRRv1");
MalVars.p1 = RegisterAddonMessagePrefix("SRv1");
MalVars.p2 = RegisterAddonMessagePrefix("SCv1");
MalVars.p3 = RegisterAddonMessagePrefix("SC2Rv1");
MalVars.p5 = RegisterAddonMessagePrefix("SReset");
MalVars.p6 = RegisterAddonMessagePrefix("SCRANK");
MalVars.p8 = RegisterAddonMessagePrefix("SCver");
MalVars.p9 = RegisterAddonMessagePrefix("SRNAME");
MalVars.p10 = RegisterAddonMessagePrefix("SRCLUE");
MalVars.p11 = RegisterAddonMessagePrefix("SCQUESTS");
MalVars.p12 = RegisterAddonMessagePrefix("SCGUILDECHO");
MalVars.p13 = RegisterAddonMessagePrefix("SCSHORTYELL");
MalVars.p15 = RegisterAddonMessagePrefix("SCSHORTEMO");
MalVars.p16 = RegisterAddonMessagePrefix("SCSHORTCUSTEMO");
MalVars.p17 = RegisterAddonMessagePrefix("FACCOMM");
MalVars.p17 = RegisterAddonMessagePrefix("poll");
MalVars.p18 = RegisterAddonMessagePrefix("test");
MalVars.p19 = RegisterAddonMessagePrefix("pollfwd");
--print(MalVars.p0);
--print(MalVars.p1);
--print(MalVars.p2);
--print(MalVars.p3);
--print(MalVars.p5);
--print(MalVars.p6);
--print(MalVars.p8);
--print(MalVars.p9);
--print(MalVars.p10);
--print(MalVars.p11);
--print(MalVars.p12);
--print(MalVars.p13);
--print(MalVars.p15);
--print(MalVars.p16);
--print(MalVars.p17);
--print(MalVars.p18);
--print(MalVars.p19);


-- #######################################################
-- initializeMarauderVars functions
-- #######################################################
function zeroVotes()
	MalVars.vote1 = 0
	MalVars.vote2 = 0
	MalVars.vote3 = 0
	MalVars.vote4 = 0
end

function initializeMarauderVars()
	--Quest vars
	MalVars.rune, MalVars.dal1, MalVars.viol, MalVars.und, MalVars.ring = 0, 0, 0, 0, 0;
	MalVars.groupName = "";																	-- Party's chosen name
	MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4 = "", "", "", "";			-- Party member names (string)
	MalVars.LastDamager = "";																-- last source name to damage a critter, used for pet kill credit
	MalVars.merch1Tlk, MalVars.merch2Tlk, MalVars.merch3Tlk = 0, 0, 0;							-- Whether each merchant has been talked to (0 or 1)
	zeroVotes();
	MalVars.checkpoint = 10;																	-- Logic flow variable (number)
	MalVars.currQuest = "q0a";																-- For display in Quest Log (string)
	MalVars.merchantClues = 0; 																-- How many group has achieved (number)
	MalVars.merchantTalkCount = 0; 															-- How many this player has spoken to (number)
	MalVars.partyBuns, MalVars.partyRats, MalVars.partyFrogs = 0, 0, 0; 						-- how many of each the party has killed
	MalVars.emoted = 0; 																		-- How many got it right
	MalVars.duelWon = 0;																		-- Locally record if a player has won a duel (0 or 1)
	MalVars.duels = 0;																			-- Accumulator for number of party duel victories (number)
	MalVars.sharked = 0;																		-- Whether a player has been killed by shark yet (0 or 1)

	--for leadership ranking
	Mchoices = {};
	MalVars.choiceA, MalVars.choiceB, MalVars.choiceC, MalVars.choiceD = "", "", "", "";
	MalVars.rankA, MalVars.rankB, MalVars.rankC, MalVars.rankD = 0, 0, 0, 0;
	MalVars.rankings = "";

	--Leave chat channels
	LeaveChannelByName(MalVars.Channels.trade);
	LeaveChannelByName(MalVars.Channels.lfg);
	LeaveChannelByName(MalVars.Channels.general);
	LeaveChannelByName(MalVars.Channels.localdefense);

	--Set tabard names for mouseover
	MaleanteTab1.tooltip:SetText(MalVars.TabardNames.t01);
	MaleanteTab2.tooltip:SetText(MalVars.TabardNames.t02);
	MaleanteTab3.tooltip:SetText(MalVars.TabardNames.t03);
	MaleanteTab4.tooltip:SetText(MalVars.TabardNames.t04);
	MaleanteTab5.tooltip:SetText(MalVars.TabardNames.t05);
	MaleanteTab6.tooltip:SetText(MalVars.TabardNames.t06);
	MaleanteTab7.tooltip:SetText(MalVars.TabardNames.t07);
	MaleanteTab8.tooltip:SetText(MalVars.TabardNames.t08);
	MaleanteTab9.tooltip:SetText(MalVars.TabardNames.t09);
	MaleanteTab10.tooltip:SetText(MalVars.TabardNames.t10);
	MaleanteTab11.tooltip:SetText(MalVars.TabardNames.t11);
	MaleanteTab12.tooltip:SetText(MalVars.TabardNames.t12);

	--Set Tracker titles here because of special characters
	MarauderTracker.title1.title:SetText(MalVars.Quests.q1ST.Title);
	MarauderTracker.q1a.text:SetText(MalVars.Quests.q1a.Title);
	MarauderTracker.q1b.text:SetText(MalVars.Quests.q1b.Title .. "(0/3)"); -- for tracking bunnies
	MarauderTracker.q1c.text:SetText(MalVars.Quests.q1c.Title .. "(0/3)"); -- for tracking merchant clues
	MarauderTracker.q1d.text:SetText(MalVars.Quests.q1d.Title);
	MarauderTracker.q1e.text:SetText(MalVars.Quests.q1e.Title);
	MarauderTracker.q1f.text:SetText(MalVars.Quests.q1f.Title);
	MarauderTracker.q1g.text:SetText(MalVars.Quests.q1g.Title);
	MarauderTracker.q1h.text:SetText(MalVars.Quests.q1h.Title);
	MarauderTracker.q1i.text:SetText(MalVars.Quests.q1i.Title);
	MarauderTracker.title2.title:SetText(MalVars.Quests.q2ST.Title);
	MarauderTracker.q2a.text:SetText(MalVars.Quests.q2a.Title);
	MarauderTracker.q2b.text:SetText(MalVars.Quests.q2b.Title);
	MarauderTracker.q2c.text:SetText(MalVars.Quests.q2c.Title);
	MarauderTracker.q2d.text:SetText(MalVars.Quests.q2d.Title);
	MarauderTracker.q2e.text:SetText(MalVars.Quests.q2e.Title);
	MarauderTracker.q2f.text:SetText(MalVars.Quests.q2f.Title .. "(0/4)"); -- for tracking frogs and rats
	MarauderTracker.q2g.text:SetText(MalVars.Quests.q2g.Title);
	MarauderTracker.title3.title:SetText(MalVars.Quests.q3ST.Title);
	MarauderTracker.q3a.text:SetText(MalVars.Quests.q3a.Title .. "(0/" .. GetNumPartyMembers() .. ")"); -- for tracking duels
	MarauderTracker.q3b.text:SetText(MalVars.Quests.q3b.Title);
	MarauderTracker.q3c.text:SetText(MalVars.Quests.q3c.Title);
	MarauderTracker.q3d.text:SetText(MalVars.Quests.q3d.Title);
	MarauderTracker.q3e.text:SetText(MalVars.Quests.q3e.Title);
	MarauderTracker.title4.title:SetText(MalVars.Quests.q4ST.Title);
	MarauderTracker.q4a.text:SetText(MalVars.Quests.q4a.Title);


	--UI Variables
	WatchFrame:Hide(); --Hide the Blizzard Quest Tracker
	--the following two get in the way of the addon quest tracker:
	MultiBarLeft:Hide(); --Hide the Blizzard Right-screen Action Bar 1
	MultiBarRight:Hide(); --Hide the Blizzard Right-screen Action Bar 2
	Marauder:Hide(); -- overhead text
	MarauderRing:Hide();
	MarauderBook:Hide();
	MarauderTracker:Hide(); -- quest tracker
	MarauderTracker.q1a.text:Hide();
	MarauderTracker.q1a.check:Hide();
	MarauderTracker.q1b.text:Hide();
	MarauderTracker.q1b.check:Hide();
	MarauderTracker.q1c.text:Hide();
	MarauderTracker.q1c.check:Hide();
	MarauderTracker.q1d.text:Hide();
	MarauderTracker.q1d.check:Hide();
	MarauderTracker.q1e.text:Hide();
	MarauderTracker.q1e.check:Hide();
	MarauderTracker.q1f.text:Hide();
	MarauderTracker.q1f.check:Hide();
	MarauderTracker.q1g.text:Hide();
	MarauderTracker.q1g.check:Hide();
	MarauderTracker.q1h.text:Hide();
	MarauderTracker.q1h.check:Hide();
	MarauderTracker.q1i.text:Hide();
	MarauderTracker.q1i.check:Hide();
	MarauderTracker.q2a.text:Hide();
	MarauderTracker.q2a.check:Hide();
	MarauderTracker.q2b.text:Hide();
	MarauderTracker.q2b.check:Hide();
	MarauderTracker.q2c.text:Hide();
	MarauderTracker.q2c.check:Hide();
	MarauderTracker.q2d.text:Hide();
	MarauderTracker.q2d.check:Hide();
	MarauderTracker.q2e.text:Hide();
	MarauderTracker.q2e.check:Hide();
	MarauderTracker.q2f.text:Hide();
	MarauderTracker.q2f.check:Hide();
	MarauderTracker.q2g.text:Hide();
	MarauderTracker.q2g.check:Hide();
	MarauderTracker.q3a.text:Hide();
	MarauderTracker.q3a.check:Hide();
	MarauderTracker.q3b.text:Hide();
	MarauderTracker.q3b.check:Hide();
	MarauderTracker.q3c.text:Hide();
	MarauderTracker.q3c.check:Hide();
	MarauderTracker.q3d.text:Hide();
	MarauderTracker.q3d.check:Hide();
	MarauderTracker.q3e.text:Hide();
	MarauderTracker.q3e.check:Hide();
	MarauderTracker.title4:Hide();
	MarauderTracker.q4a.text:Hide();
	MarauderTracker.q4a.check:Hide();
	MarauderScreenText:SetText(" ");
	clearVote(); -- hides the tabard voting screen
	MSurveyFrame.va1:Hide();
	MSurveyFrame.va2:Hide();
	MSurveyFrame.va3:Hide();
	MSurveyFrame.va4:Hide();
	MSurveyFrame.vb1:Hide();
	MSurveyFrame.vb2:Hide();
	MSurveyFrame.vb3:Hide();
	MSurveyFrame.vb4:Hide();
	MSurveyFrame.vc1:Hide();
	MSurveyFrame.vc2:Hide();
	MSurveyFrame.vc3:Hide();
	MSurveyFrame.vc4:Hide();
	MSurveyFrame.vd1:Hide();
	MSurveyFrame.vd2:Hide();
	MSurveyFrame.vd3:Hide();
	MSurveyFrame.vd4:Hide();

end







-- #######################################################
-- OnUpdate listener
-- #######################################################

local UpdateFrame = CreateFrame("Frame");
UpdateFrame.name = "MarauderUpdateEventFrame";
UpdateFrame:SetScript("OnUpdate", function(self,elapsed)
	-- Fix the discontinuity/coords bug crossing between mainstreet Dalaran and the Underbelly
	if (closeEnough(0, 0, 0) == 1) then
		--SCworldMapAutoToggle = "1"
		ToggleFrame(WorldMapFrame);
		ToggleFrame(WorldMapFrame);
		--SCworldMapAutoToggle = "0"
	end;
end);


-- #######################################################
-- tallyVotes function for tabard voting
-- #######################################################
function tallyVotes(pl1, pl2, pl3, pl4)
	--trace("tallyVotes function was called by the researcher addon in response to getting a single player vote");
	--Display results of all voters on researcher's overhead display (2 players on a line to fit in overhead)
	--Note that the researcher is not allowed to vote (won't send the message that triggers the logic)
	--So do vote testing from the "player" machine if dual-boxing...
	--THIS logic block functions for the researcher's addon only (it's a function that's called locally by the researcher)

	if (GetNumPartyMembers() == 0) then -- solo, no group
		--Should really be testing this with a group, but...
		--trace("Entered the tallyVotes function, but you're not in a group...");
		AddToOverhead(MalVars.ScreenTxt.line0090);

	elseif (GetNumPartyMembers() == 1) then -- dual box testing
		--Only one player, OK not to check whether all have voted
		--trace("should be printing out 1 vote overhead");
		if (MalVars.vote1 == 8) then
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. "\n" .. MalVars.ScreenTxt.line0091);
			--trace("The one testing player chose the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. MalVars.vote1);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	elseif ((GetNumPartyMembers() == 2) and (MalVars.vote1 ~= 0) and (MalVars.vote2 ~= 0)) then
		--Playtesting with 3: 2 party members, and both have voted (neither of the two are nil)
		--trace("should be printing out two votes overhead");
		if ((MalVars.vote1 == 8) and (MalVars.vote2 == 8)) then
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. " ... " .. pl2 .. ": " .. MalVars.vote2 .. "\n" .. MalVars.ScreenTxt.line0091);
			--trace("Both players agreed on the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. " ... " .. pl2 .. ": " .. MalVars.vote2);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	elseif ((GetNumPartyMembers() == 3) and (((MalVars.vote1 ~= 0) and (MalVars.vote2 ~= 0)) or ((MalVars.vote1 ~= 0) and (MalVars.vote3 ~= 0)) or ((MalVars.vote2 ~= 0) and (MalVars.vote3 ~= 0)))) then
		--Playing with 4: 3 party members, short one, and at least 2 have voted
		--trace("should be printing out three votes overhead");
		if ((MalVars.vote1 == 8) and (MalVars.vote2 == 8) and (MalVars.vote3 == 8)) then
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. " ... " .. pl2 .. ": " .. MalVars.vote2 .. "\n" .. pl3 .. ": " .. MalVars.vote3 .. "\n" .. MalVars.ScreenTxt.line0091);
			--trace("All 3 players agreed on the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		elseif (((MalVars.vote1 == 8) and (MalVars.vote2 == 8)) or ((MalVars.vote2 == 8) and (MalVars.vote3 == 8)) or ((MalVars.vote1 == 8) and (MalVars.vote3 == 8))) then
			--2 of the 3 voting correctly but the other one lagging or not participating
			SendAddonMessage("SRv1", "INCOMPLETE", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. " ... " .. pl2 .. ": " .. MalVars.vote2 .. "\n" .. pl3 .. ": " .. MalVars.vote3);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	elseif ((GetNumPartyMembers() == 4) and (((MalVars.vote1 ~= 0) and (MalVars.vote2 ~= 0) and (MalVars.vote3 ~= 0)) or ((MalVars.vote2 ~= 0) and (MalVars.vote3 ~= 0) and (MalVars.vote4 ~= 0)) or ((MalVars.vote1 ~= 0) and (MalVars.vote2 ~= 0) and (MalVars.vote4 ~= 0)) or ((MalVars.vote1 ~= 0) and (MalVars.vote3 ~= 0) and (MalVars.vote4 ~= 0)))) then
		--Playing with a full party: 4 party members, and at least 3 have voted
		--trace("should be printing out four votes overhead");
		if ((MalVars.vote1 == 8) and (MalVars.vote2 == 8) and (MalVars.vote3 == 8) and (MalVars.vote4 == 8)) then
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. " ... " .. pl2 .. ": " .. MalVars.vote2 .. "\n" .. pl3 .. ": " .. MalVars.vote3 .. " ... " .. pl4 .. ": " .. MalVars.vote4 .. "\n" .. MalVars.ScreenTxt.line0091);
			--trace("3 out of 4 dentists surveyed agreed on the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		elseif ((MalVars.vote1 == 8) and (MalVars.vote2 == 8) and (MalVars.vote3 == 8)) or ((MalVars.vote2 == 8) and (MalVars.vote3 == 8) and (MalVars.vote4 == 8)) or ((MalVars.vote1 == 8) and (MalVars.vote2 == 8) and (MalVars.vote4 == 8)) or ((MalVars.vote1 == 8) and (MalVars.vote3 == 8) and (MalVars.vote4 == 8)) then
			--3 of the 4 voting correctly but the other one lagging or not participating
			SendAddonMessage("SRv1", "INCOMPLETE", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. MalVars.vote1 .. " ... " .. pl2 .. ": " .. MalVars.vote2 .. "\n" .. pl3 .. ": " .. MalVars.vote3 .. " ... " .. pl4 .. ": " .. MalVars.vote4);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	else
		--trace("Submitted a button click, but apparently not everyone has voted yet so no overhead display or correct/incorrect message");
		--trace("Check matching logic of number in party and VoteX variables");
	end;
end;
-- #######################################################



local ListenFrame = CreateFrame("Frame");
ListenFrame:RegisterEvent("CHAT_MSG_ADDON");

ListenFrame:SetScript("OnEvent", function(self, event, prefix, msg, channel, sender)

	--##############################################################
	--Researcher-initiated messages (by button click)
	--##############################################################
	if (prefix == "SRRv1") then --> registering the participant researcher's avatar name
		MalVars.res = sender;
		--print("For testing only: " .. MalVars.res .. " is the participant researcher in the party")

	elseif (prefix == "SReset") then
		setCheckpoint(tonumber(msg));

	elseif ((prefix == "SCver") and (MalVars.isRes == 1)) then
		trace(MalVars.WhisperTxt.line0020 .. msg .. "|r -- "..sender);

	elseif (prefix == "SRNAME") then
		trace(MalVars.WhisperTxt.line0030 .. msg);
		MalVars.groupName = msg;

	elseif (prefix == "SRCLUE") then
		MalVars.code = msg;

	elseif ((prefix == "SCQUESTS") and (MalVars.isRes == 1)) then
		--send quest accepts and completes to researcher, who will then echo to any logged on guild members with Marauder installed
		--trace("|cffff8000" .. sender .. "|r " .. msg);
		local fwd = sender .. "#" .. msg;
		SendAddonMessage("SCGUILDECHO", fwd, "GUILD")

	elseif ((prefix == "SCGUILDECHO") and (MalVars.isRes ~= 1)) then
		--don't echo these to researcher
		local playername, questevent = strsplit("#", msg, 2);
		trace("|cffff8000" .. playername .. "|r " .. " " .. questevent);

	elseif ((prefix == "SCSHORTYELL") and ((GetUnitName("player") == "Vaas") or (GetUnitName("player") == "Izuna") or (GetUnitName("player") == "Izunai"))) then
		--for testing only; will be sent to log instead
		--trace("Got yell report from " .. sender .. ": " .. msg);
		local output = "Y#" .. sender .. "#" .. msg .. "\r"
		sendToOffFacResearcherLogger(output, "chatAndEvents", MalVars.sourceBaddie)

	elseif ((prefix == "SCSHORTEMO") and ((GetUnitName("player") == "Vaas") or (GetUnitName("player") == "Izuna") or (GetUnitName("player") == "Izunai"))) then
		--for testing only; will be sent to log instead
		--trace("Got emote report from " .. sender .. ": " .. msg);
		--local output = "E#" .. sender .. "#" .. msg .. "\r"
		sendToOffFacResearcherLogger(msg, "chatAndEvents", MalVars.sourceBaddie)

	elseif ((prefix == "SCSHORTCUSTEMO") and ((GetUnitName("player") == "Vaas") or (GetUnitName("player") == "Izuna") or (GetUnitName("player") == "Izunai"))) then
		--for testing only; will be sent to log instead
		--trace("Got custom emote report from " .. sender .. ": " .. msg);
		--local output = "CE#" .. sender .. "#" .. msg .. "\r"
		sendToOffFacResearcherLogger(msg, "chatAndEvents", MalVars.sourceBaddie)

	--this is the polling for same-faction (Aladriaa) and off-faction observers, not for players
	elseif (((prefix == "pollfwd") and (MalVars.isRes ~= 1)) or ((prefix == "poll") and (channel == "GUILD") and (GetUnitName("player") ~= "Izuna") and (GetUnitName("player") ~= "Izunai")) or ((prefix == "poll") and ((channel == "WHISPER") and ((sender == "Izuna") or (sender == "Izunai"))))) then
		--print("got as far as entering the poll prefix listener on Maleante.lua")
		if (GetUnitName("Player") == MalVars.nAla) then
			if (MalVars.sameLogs == 0) then
				trace(MalVars.WhisperTxt.line0025 .. MalVars.nSed);
				MalVars.sameLogs = 1
			end
		elseif (prefix ~= "pollfwd") then
			MalVars.listeners = 1;
			MalVars.sourceBaddie = sender;
			if (MalVars.offLogs == 0) then
				trace(MalVars.WhisperTxt.line0025 .. MalVars.sourceBaddie);
				MalVars.offLogs = 1
			end
		end

		local facing = GetPlayerFacing()

		local SCzone = GetZoneText("player")
		local SCsubzone = GetSubZoneText("player")
		local SCprintZone = ""
		if (SCsubzone == "") then
			SCprintZone = SCzone;
		else
			SCprintZone = SCsubzone;
		end
		--Add for Spanish version, translate to English zone name for logs
		if ((GetLocale() == "esMX") or (GetLocale() == "esES")) then
			SCprintZone = malTranslate(SCprintZone);
		end
		--print("SCprintZone: "..SCprintZone)

		local speed = GetUnitSpeed("player")
		local movement = ""

		if speed == 7 then
			movement = "Normal running"
		elseif speed == 2.5 then
			movement = "Walking"
		elseif speed == 4.5 then
			movement = "Running backwards"
		elseif speed == 26.6 then
			movement = "Epic flying mount"
		elseif speed == 4.7222199440002 then
			movement = "Swimming"
		elseif speed == 0 then
			movement = "Still"
		else
			movement = "unknown"
		end

		local unitX, unitY = GetPlayerMapPosition("player")
		local output = "P#" .. msg .. "#" .. GetUnitName("player") .. "#" .. SCprintZone .. "#" ..tostring(unitX) .. "#" .. tostring(unitY) .. "#0.0#" .. facing .. "#" .. movement .. "\r"
		--print("call sendToOffFacResearcherLogger in the poll section of Marauder.lua listener")

		if (MalVars.sameFacMsg == 1) then
			SendAddonMessage("log", output, "WHISPER", MalVars.nSed);
		else
			sendToOffFacResearcherLogger(output, "chatAndEvents", sender)
		end

		--to fix
		--elseif ((prefix == "ALACHAT") and ((UnitName("player") == "Seddrik") or (UnitName("player") == "Sedrick")) then
			--echo chat from Aladria to log
			--local output = "
			--sendToResearcherLogger..

	elseif ((prefix == "SCRANK") and (MalVars.isRes == 1)) then
		--Researcher only, not translated
		trace("|cffff8000" .. sender .. " voted: |r" .. msg);

	elseif (prefix == "SRv1") then --> came from the researcher's addon sent to the party
		--trace("got researcher directive");
		--print(string.format("Received directive from Researchers: [%s] [%s]: %s %s", channel, sender, prefix, msg));

		if msg == "INIT" then
			--trace("Received INIT command");
			--ToDo: make changes to default UI recoverable at the end (check to see if these are set, and put them back if so)
			--ToDo: add an "away message" function that will also be disabled at the end
			--report back to researcher that addon is properly installed and working (and whether researcher flag is set)
			--Researcher only, not translated
			MalVars.res = sender;
			if ((MalVars.isRes == 0) or (MalVars.isRes == nil)) then
				SendAddonMessage("Mver", MalVars.version .." (PLAYER)", "PARTY");
			elseif (MalVars.isRes == 1) then
				SendAddonMessage("Mver ", MalVars.version .." (RESEARCHER)", "PARTY");
			end;
			initializeMarauderVars();

		elseif ((msg == "RING") and (GetSubZoneText() == MalVars.Zones.violetstand)) then
			--researcher makes the ring visible... it will stay visible for the rest of the quest
			MarauderRing:Show();
			MarauderRingVisible = true;
			if (MalVars.isRes == 0) then
				MalVars.checkpoint = 20;
			end

		elseif ((msg == "CUT-1") and (GetSubZoneText() == MalVars.Zones.violetstand)) then
			--displays book icon to access quest log
			--trace("Received WHISPER command");
			MalVars.checkpoint = 40;
			ChatWhisper2(MalVars.nAla, MalVars.ScreenTxt.line0011a, MalVars.nAla, MalVars.ScreenTxt.line0011b);
			ChatWhisper(MalVars.nAla, MalVars.ScreenTxt.line0012);
			transition000Handler(); --the delay animation to allow the above text to be read for a few seconds, then lead into cutscene

		elseif (msg == "STEALME") then
			PlaySound("Stealth", "Master");

		elseif (msg == "ASSASSIN") then
			rogueSoundLauncher(0);

		elseif ((msg == "GO") and ((GetSubZoneText() == MalVars.Zones.violetstand) or (GetSubZoneText() == MalVars.Zones.forlornwoods) or (GetSubZoneText() == MalVars.Zones.twilightrivulet))) then
			--trace("Received GO command");
			if ((MalVars.isRes == nil) or (MalVars.isRes == 0)) then
			--check for repeats: Mrpt set when the quest starts, stored at logout
				if (Mrpt ~= nil) then
					--trace("SCrpt was not nil: " .. SCrpt)
					MalVars.repeatPlay = Mrpt;
				end
				if (MalVars.repeatPlay == 1) then
					--trace("MalVars.repeatPlay was 1")
					SendAddonMessage("SC2Rv1", "RPT", "PARTY");
				end
				MalVars.checkpoint = 90;
			elseif (MalVars.isRes == 1) then
				AddToOverhead(MalVars.ScreenTxt.line0015);
				--AND (as of 3.1.9) triggers next quest manually for the researcher, who doesn't need to click ring near librarian
				AddToQuestWindow(MalVars.nLib, "offer", MalVars.Quests.q1a.Title, MalVars.Quests.q1a.OffTop, MalVars.Quests.q1a.OffBot);
				MalVars.currQuest = "q1a";
				MalVars.checkpoint = 100;
				--Tracker: display text for quest 1a
				MarauderTracker.q1a.text:Show();
			else
				MalVars.checkpoint = 90;
			end
			Mrpt = 1;

		elseif ((msg == "INCOMPLETE") and (MalVars.isRes == 0)) then
			--trace("received the INCOMPLETE mesage from researcher addon for tabard voting");
			--Generated by all but one getting the right choice but one not voting at all
			--Don't reset anything, but send a message to the overhead letting them know that one player hasn't voted
			AddToOverhead(MalVars.ScreenTxt.line0093);

		elseif ((msg == "INCORRECT") and (MalVars.isRes == 0)) then
			--trace("received the INCORRECT message from researcher addon for tabard voting");
			--Generated by the majority of the group voting but selecting different icons (not agreeing)
			--Message (overhead) from Aladriaa telling them it's wrong, and that they have to re-vote
			--Researcher doesn't get this message, since it would overwrite the vote summary overhead
			AddToOverhead(MalVars.ScreenTxt.line0095);
			--Also re-set the vote variables so that everyone has to vote again, rather than just one person changing their vote
			zeroVotes(); -- same function called with INIT to initialize them all to zero

		elseif (msg == "CORRECT") then
			--Generated by the majority of the group selecting the correct tabard icon
			--trace("Received CORRECT command from researcher addon for tabard voting");
			MalVars.checkpoint = 210;
			clearVote();
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q1d.Title, MalVars.Quests.q1d.CompTop);
			--Tracker: completed quest 1d
			MarauderTracker.q1d.check:Show();

		elseif (msg == "TRADED") then
			--The party has successfully given the items to Calliopeia
			MalVars.checkpoint = 310;
			ChatWhisper(MalVars.nCal, MalVars.WhisperTxt.line0081);
			AddToQuestWindow(MalVars.nCal, "complete", MalVars.Quests.q1h.Title, MalVars.Quests.q1h.CompTop);
			--Tracker: complete quest 1h
			MarauderTracker.q1h.check:Show();

		elseif (msg == "REPORT-1") then
			--After talking to Calliopeia, they're prompted to report their findings. This message comes from the REPORT-1 button saying that the report was accepted
			--This is the message from the button pressed by the researcher indicating that Aladriaa's first requested report was accepted
			--trace("Received REPORT-1 command");
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q1i.Title, MalVars.Quests.q1i.CompTop);
			SCachieve(MalVars.AchTxt.p2);
			--This string should only be present starting with this event, needs to be here and to be translated
			MalVars.whoClue = "El tabardo con la bobina de Tesla\n     Lo Sociedad Mec\195\161nica Ninja";
			MQLLeftFrameScrollFrameScrollChildFrameClues3:Show();
			MalVars.checkpoint = 340;
			--Tracker: complete quest 1i
			MarauderTracker.q1i.check:Show();

		elseif (msg == "ZAP") then
			--trace("Received ZAP command");
			zapMe();

		elseif (msg == "BRIBED") then
			--successfully bribed Calliopeia
			AddToQuestWindow(MalVars.nCal, "complete", MalVars.Quests.q2a.Title, MalVars.Quests.q2a.CompTop);
			MalVars.checkpoint = 370;
			--Tracker: complete quest 2a
			MarauderTracker.q2a.check:Show();

		--elseif (msg == "CODE") then
			--successfully solved code -- this is the version sent by the researcher button
			--NOW (3.1.9) this will be automated by the chat listener matching at MalVars.checkpoint 390

		elseif (msg == "SEWERKILL") then
			--manually set completion of rat/frog task in case something goes wrong
			local critters = 4;
			local qtext = MarauderTracker.q2f.text:GetText();
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/4%)", "%1%("..critters.."\/4%)", 1))
			MarauderTracker.q2f.text:SetText(newqtext);
			AddToQuestWindow(MalVars.nJin, "complete", MalVars.Quests.q2f.Title, MalVars.Quests.q2f.CompTop);
			ChatWhisper(MalVars.nJin, MalVars.WhisperTxt.line0091);
			MalVars.checkpoint = 540;
			--Tracker: completed quest 2f
			MarauderTracker.q2f.check:Show();

		elseif (msg == "REPORT-2") then
			--trace("Received REPORT command");
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q2g.Title, MalVars.Quests.q2g.CompTop);
			SCachieve(MalVars.AchTxt.p3);
			--This string should only be present starting with this event, needs to be here and to be translated
			MalVars.whatClue = "Construyendo una m\195\161quina\n     para derribar a Dalaran";
			MQLLeftFrameScrollFrameScrollChildFrameClues4:Show();
			MalVars.checkpoint = 570;
			--Tracker: complete quest 2g
			MarauderTracker.q2g.check:Show();

		elseif (msg == "REPORT-3") then -- Aladriaa accepts the players' report after cutscene 2
			--trace("Received REPORT command");
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q3d.Title, MalVars.Quests.q3d.CompTop);
			SCachieve(MalVars.AchTxt.p4);
			--This string should only be present starting with this event, needs to be here and to be translated
			MalVars.howClue = "La m\195\161quina usa magia par funcionar...\n     Utilicen magia para vencerla";
			MQLLeftFrameScrollFrameScrollChildFrameClues5:Show();
			MalVars.checkpoint = 720;
			--Tracker: complete quest 3d
			MarauderTracker.q3d.check:Show();

		elseif (msg == "MOBS") then
			--Researcher button, so the researcher can wait until the NPC is ready to spring
			--trace("Received MOBS command");
			MalVars.checkpoint = 770;
			AddToOverheadQuick(MalVars.ScreenTxt.line0125); --announces the boss' warcry outside the pink circle
			PlaySoundFile("Interface\\AddOns\\Maleante\\Sounds\\bossBattleYell.mp3");

		elseif (msg == "BOSS") then
			--Manually triggered after the low-level opponents are defeated, signaling time for boss to join
			MalVars.checkpoint = 810;
			AddToOverhead(MalVars.ScreenTxt.line0145); --fight's not over yet
			--Removed for 4.1
			--PlaySoundFile("Interface\\AddOns\\Maleante\\Sounds\\bossBattleYell.mp3");
			--PlaySound("Stealth", "Master");
			PlaySoundFile("Interface\\AddOns\\Maleante\\Sounds\\bossBattleYell.mp3");

		elseif (msg == "BOOM") then
			--received BOOM command, triggers cutscene 3
			MalVars.checkpoint = 820;
			transition300Handler();

		--elseif msg == "(%a+)||(%a+)||(%a+)||(%a+)" then
		elseif (msg == "LEADER") then
			--trace("received LEADER command, starting leadership voting");
			MalVars.checkpoint = 850;
			MalVars.res = sender;
			--Do a fresh name check, just in case someone crashed out, etc...
			MalVars.pName0 = GetUnitName("player");
			MalVars.pName1 = GetUnitName("party1");
			MalVars.pName2 = GetUnitName("party2");
			MalVars.pName3 = GetUnitName("party3");
			if GetNumPartyMembers() == 4 then
				MalVars.pName4 = GetUnitName("party4");
			else
				MalVars.pName4 = nil;
			end
			--Make sure the variables are nil and the table is empty before the following logic
			MalVars.choiceA = nil;
			MalVars.choiceB = nil;
			MalVars.choiceC = nil;
			MalVars.choiceD = nil;
			for i = 1, #Mchoices do
				table.remove(Mchoices, i);
			end
			--Uses the MalVars.res variable (refreshed in this function, not set during INIT) to populate all the non-researcher player names for the choices to vote for
			if MalVars.pName0 ~= MalVars.res then
				table.insert(Mchoices, MalVars.pName0)
			end
			if ((MalVars.pName1 ~= nil) and (MalVars.pName1 ~= MalVars.res)) then
				table.insert(Mchoices, MalVars.pName1);
			--MQuestFrame.LdrButton1:Show(); -- each of these
			end
			if ((MalVars.pName2 ~= nil) and (MalVars.pName2 ~= MalVars.res)) then
				table.insert(Mchoices, MalVars.pName2);
			--MQuestFrame.LdrButton2:Show();
			end
			if ((MalVars.pName3 ~= nil) and (MalVars.pName3 ~= MalVars.res)) then
				table.insert(Mchoices, MalVars.pName3);
			--MQuestFrame.LdrButton3:Show();
			end
			if ((MalVars.pName4 ~= nil) and (MalVars.pName4 ~= MalVars.res)) then
				table.insert(Mchoices, MalVars.pName4);
			--MQuestFrame.LdrButton4:Show();
			end
			MalVars.choiceA = Mchoices[1];
			MalVars.choiceB = Mchoices[2];
			MalVars.choiceC = Mchoices[3];
			MalVars.choiceD = Mchoices[4];
			AddToRankWindow(MalVars.nLdr, MalVars.Quests.q4b.Title, MalVars.Quests.q4b.VoteTop, MalVars.choiceA, MalVars.choiceB, MalVars.choiceC, MalVars.choiceD)

		elseif (msg == "DONE") then
			--trace("recieved the DONE command from researcher");
			MalVars.checkpoint = 860;
			MarauderTracker:Hide();
			Marauder:Hide(); -- overhead text
			MarauderRing:Hide();
			MarauderBook:Hide();
			theEndTitle();
			--and tie that graphic's close handler to clean up changes that have been made to the interface

		elseif (msg == "STATUS") then
			local playertype = "";
			--trace("received the STATUS command from researcher");
			if (MalVars.isRes == 1) then
				playertype = "researcher";
			elseif ((MalVars.isRes == 0) or (MalVars.isRes == nil)) then
				playertype = "player";
			end;
			--Researcher only, doesn't need to be translated
			local values = "Status for " .. GetUnitName("player") .. ": MalVars.currQuest " .. MalVars.currQuest .. "; MalVars.checkpoint " .. tostring(MalVars.checkpoint) .. "; (" .. playertype .. ")"
			SendAddonMessage("SC2Rv1", values, "PARTY");

		elseif (msg == "ACH1") then
			SCachieve(MalVars.AchTxt.a1a, MalVars.AchTxt.a1b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a1a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH2") then
			SCachieve(MalVars.AchTxt.a2a, MalVars.AchTxt.a2b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a2a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH3") then
			SCachieve(MalVars.AchTxt.a3a, MalVars.AchTxt.a3b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a3a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH4") then
			SCachieve(MalVars.AchTxt.a4a, MalVars.AchTxt.a4b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a4a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH5") then
			SCachieve(MalVars.AchTxt.a5a, MalVars.AchTxt.a5b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a5a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH6") then
			SCachieve(MalVars.AchTxt.a6a, MalVars.AchTxt.a6b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a6a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH7") then
			SCachieve(MalVars.AchTxt.a7a, MalVars.AchTxt.a7b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a7a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH8") then
			SCachieve(MalVars.AchTxt.a8a, MalVars.AchTxt.a8b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a8a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH9") then
			SCachieve(MalVars.AchTxt.a9a, MalVars.AchTxt.a9b)
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. MalVars.AchTxt.a9a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH13") then
			--No longer an achievement button... enable the participant code (no longer load on demand of a separate addon)
			if (MalVars.initializedParticipant == 1) then
				SendAddonMessage("SC2Rv1", "LOADEDALREADY", "PARTY");
			elseif (MalVars.initializedParticipant == 0) then
				initializeParticipantSection()
				trace(MalVars.WhisperTxt.line0015 .. sender)
				MarauderHat:Show();
				SendAddonMessage("SC2Rv1", "LOADED", "PARTY");
				local output = "LD#" .. GetUnitName("Player") .. "#loaded MalParticipant, MaleanteVersion: " .. MalVars.version .. ":" .. MalVars.repeatPlay .. "\r";
				sendToResearcherLogger(output);
			else
				--probably means that MalVars.initializedParticipant is nil, which means something didn't load properly
				trace(MalVars.WhisperTxt.line0016)
			end
		end



	--##############################################################
	--Player-initiated messages to players (driven by events)
	--##############################################################



	elseif (prefix == "SCv1") then --> came from other players' addon
		--trace("got player report");
		--print(string.format("Received report from other player: [%s] [%s]: %s %s", channel, sender, prefix, msg));


		if (msg == "AXE") then
			-- Talking to Axechewer (triggered by ring click with whole party nearby)
			AddToQuestWindow(MalVars.nAxe, "complete", MalVars.Quests.q1a.Title, MalVars.Quests.q1a.CompTop);
			MalVars.checkpoint = 120;
			--Tracker: complete quest 1a
			MarauderTracker.q1a.check:Show();

		elseif ((msg == "BUNNYKILL") or (msg == "BUNNYKILLPET")) then
			-- Fires each time a rabbit is killed (triggered by combat listener)
			--trace("MalVars.partyBuns before the current event: " .. MalVars.partyBuns)
			local killer = "";
			if (msg == "BUNNYKILL") then
				killer = sender;
			elseif (msg == "BUNNYKILLPET") then
				killer = MalVars.ScreenTxt.line0035 .. sender;
			end
			MalVars.partyBuns = MalVars.partyBuns + 1;
			PlaySoundFile("Interface\\AddOns\\Maleante\\Sounds\\machineComplete_0.mp3");
			if (MalVars.checkpoint == 140) then
				AddToOverhead(killer .. MalVars.ScreenTxt.line0036 .. " (" .. MalVars.partyBuns .. "/3)");
				--Tracker: update quest text for 1b (x/3)
				local qtext = MarauderTracker.q1b.text:GetText();
				--trace("text of q1b retrieved: " .. qtext);
				--Look for pattern of text and (x/3), update with current version of MalVars.partyBuns for x
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..MalVars.partyBuns.."\/3%)", 1))
				MarauderTracker.q1b.text:SetText(newqtext);
				if MalVars.partyBuns == 3 then
					AddToQuestWindow(MalVars.nAxe, "complete", MalVars.Quests.q1b.Title, MalVars.Quests.q1b.CompTop);
					MalVars.checkpoint = 150;
					--Tracker: complete quest 1b
					MarauderTracker.q1b.check:Show();
				end;
			end;

		elseif ((msg == "SQUIRRELKILL") or (msg == "SQUIRRELKILLPET")) then
			-- Fires each time a squirrel is killed (triggered by combat listener)
			local killer = "";
			if (msg == "SQUIRRELKILL") then
				killer = sender
			elseif (msg == "SQUIRRELKILLPET") then
				killer = MalVars.ScreenTxt.line0035 .. sender;
			end
			MalVars.partyBuns = MalVars.partyBuns + 1;
			PlaySoundFile("Interface\\AddOns\\Maleante\\Sounds\\machineComplete_0.mp3");
			if (MalVars.checkpoint == 140) then
				AddToOverhead(killer .. MalVars.ScreenTxt.line0037 .. "(" .. MalVars.partyBuns .. "/3)");
				--Tracker: update quest text for 1b (x/3)
				local qtext = MarauderTracker.q1b.text:GetText();
				--trace("text of q1b retrieved: " .. qtext);
				--Look for pattern of text and (x/3), update with current version of MalVars.partyBuns for x
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..MalVars.partyBuns.."\/3%)", 1))
				MarauderTracker.q1b.text:SetText(newqtext);
				if MalVars.partyBuns == 3 then
					AddToQuestWindow(MalVars.nAxe, "complete", MalVars.Quests.q1b.Title, MalVars.Quests.q1b.CompTop);
					MalVars.checkpoint = 150;
					--Tracker: complete quest 1b
					MarauderTracker.q1b.check:Show();
				end;
			end;

		-- ###########
		-- MERCHANTS
		-- ###########
		elseif (msg == "MERCH1") then
			-- Talking to Merchant1 (Jepetto) (triggered by ring click nearby)
			MalVars.merch1Tlk = 1;
			MalVars.merchantClues = MalVars.merchantClues + 1;
			if (MalVars.merchantClues == 1) then
				rogueSoundLauncher(2)
			end
			if (MalVars.merchantClues < 3) then
				AddToOverhead("Jepetto" .. MalVars.ScreenTxt.line0081 .. sender .. "\nen " .. MalVars.Zones.wonderworks .. " (" .. MalVars.merchantClues .. "/3)");
			elseif (MalVars.merchantClues == 3) then		--done with clue gathering
				MalVars.checkpoint = 180;
				AddToOverhead("Jepetto" .. MalVars.ScreenTxt.line0081 .. sender .. "\nen " .. MalVars.Zones.wonderworks .. MalVars.ScreenTxt.line0082 .. " (3/3)");
				AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q1c.Title, MalVars.Quests.q1c.CompTop, MalVars.Quests.q1c.ComBot);
				--Tracker: complete quest 1c
				MarauderTracker.q1c.check:Show();
			end;
			--Tracker: update quest text for 1c (x/3) whether it's complete or not
			local qtext = MarauderTracker.q1c.text:GetText();
			--trace("text of q1c retrieved: " .. qtext);
			--Look for pattern of text and (x/3), update with current version of MalVars.merchantClues for x
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..MalVars.merchantClues.."\/3%)", 1))
			MarauderTracker.q1c.text:SetText(newqtext);

		elseif (msg == "MERCH2") then
			-- Talking to Merchant2 (Karadonna) (triggered by ring click nearby)
			MalVars.merch2Tlk = 1;
			MalVars.merchantClues = MalVars.merchantClues + 1;
			if (MalVars.merchantClues == 1) then
				rogueSoundLauncher(2)
			end
			if (MalVars.merchantClues < 3) then
				AddToOverhead("Karadonna" .. MalVars.ScreenTxt.line0081 .. sender .. "\nen " .. MalVars.Zones.threadsoffate .. " (" .. MalVars.merchantClues .. "/3)");
			elseif (MalVars.merchantClues == 3) then		--done with clue gathering
				MalVars.checkpoint = 180;
				AddToOverhead("Karadonna" .. MalVars.ScreenTxt.line0081 .. sender .. "\nen " .. MalVars.Zones.threadsoffate .. MalVars.ScreenTxt.line0082 .. " (3/3)");
				AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q1c.Title, MalVars.Quests.q1c.CompTop, MalVars.Quests.q1c.ComBot);
				--Tracker: complete quest 1c
				MarauderTracker.q1c.check:Show();
			end;
			--Tracker: update quest text for 1c (x/3) whether it's complete or not
			local qtext = MarauderTracker.q1c.text:GetText();
			--trace("text of q1c retrieved: " .. qtext);
			--Look for pattern of text and (x/3), update with current version of MalVars.merchantClues for x
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..MalVars.merchantClues.."\/3%)", 1))
			MarauderTracker.q1c.text:SetText(newqtext);

		elseif (msg == "MERCH3") then
			-- Talking to Merchant3 (Amisi) (triggered by ring click nearby)
			MalVars.merch3Tlk = 1;
			MalVars.merchantClues = MalVars.merchantClues + 1;
			if (MalVars.merchantClues == 1) then
				rogueSoundLauncher(2)
			end
			if (MalVars.merchantClues < 3) then
				AddToOverhead("Amisi" .. MalVars.ScreenTxt.line0081 .. sender .. "\nen " .. MalVars.Zones.legerdemainlounge .. " (" .. MalVars.merchantClues .. "/3)");
			elseif (MalVars.merchantClues == 3) then		--done with clue gathering
				MalVars.checkpoint = 180;
				AddToOverhead("Amisi" .. MalVars.ScreenTxt.line0081 .. sender .. "\nen " .. MalVars.Zones.legerdemainlounge .. MalVars.ScreenTxt.line0082 .. " (3/3)");
				AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q1c.Title, MalVars.Quests.q1c.CompTop, MalVars.Quests.q1c.ComBot);
				--Tracker: complete quest 1c
				MarauderTracker.q1c.check:Show();
			end;
			--Tracker: update quest text for 1c (x/3) whether it's complete or not
			local qtext = MarauderTracker.q1c.text:GetText();
			--trace("text of q1c retrieved: " .. qtext);
			--Look for pattern of text and (x/3), update with current version of MalVars.merchantClues for x
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..MalVars.merchantClues.."\/3%)", 1))
			MarauderTracker.q1c.text:SetText(newqtext);

		elseif (msg == "GRAVEYARD") then
			AddToQuestWindow(MalVars.nAxe, "complete", MalVars.Quests.q1e.Title, MalVars.Quests.q1e.CompTop)
			MalVars.checkpoint = 240;
			--Tracker: complete quest 1e
			MarauderTracker.q1e.check:Show();

		elseif (msg == "FORGE") then
			AddToQuestWindow(MalVars.nRhu, "complete", MalVars.Quests.q1f.Title, MalVars.Quests.q1f.CompTop)
			MalVars.checkpoint = 270;
			--Tracker: complete quest 1f
			MarauderTracker.q1f.check:Show();

		elseif (msg == "COPPER") then
			AddToOverheadQuick("\194\161" .. sender .. MalVars.ScreenTxt.line0098);
			--and the quest is completed at the end of the overhead message's display

		elseif (msg == "WHADDAYAWANT") then
			AddToOverhead(MalVars.ScreenTxt.line0100);

		elseif (msg == "COIN") then
			AddToOverhead(MalVars.ScreenTxt.line0105);

		elseif (msg == "SOLVED") then
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q2b.Title, MalVars.Quests.q2b.CompTop);
			MQLLeftFrameScrollFrameScrollChildFrameClues2:Show();
			MalVars.checkpoint = 400;
			--Tracker:complete quest 2b
			MarauderTracker.q2b.check:Show();

		elseif (msg == "CHALLENGE") then
			--clicking near Azukk, rather than saying code word
			AddToOverhead(MalVars.ScreenTxt.line0107a);

		elseif (msg == "AZUKK") then
			-- Talking to Azukk (triggered by ring click with 420)
			MalVars.checkpoint = 430;
			AddToQuestWindow(MalVars.nAzu, "complete", MalVars.Quests.q2c.Title, MalVars.Quests.q2c.CompTop)
			--Tracker: Completed quest 2c
			MarauderTracker.q2c.check:Show();

		elseif (msg == "EMOTED") then
			-- Fires each time a player chooses the proper emote (triggered by emote listener)
			MalVars.emoted = MalVars.emoted + 1;
			if (MalVars.emoted >= GetNumPartyMembers()) then -- >= to account for the possibility of the researcher doing the emote too
				MalVars.checkpoint = 470;
				AddToQuestWindow(MalVars.nAzu, "complete", MalVars.Quests.q2d.Title, MalVars.Quests.q2d.CompTop);
				--Tracker: complete quest 2d
				MarauderTracker.q2d.check:Show();
			end;

		elseif (msg == "SEWERS") then
			-- Talking to Jindall (triggered by ring click nearby)
			MalVars.checkpoint = 500;
			AddToQuestWindow(MalVars.nJin, "complete", MalVars.Quests.q2e.Title, MalVars.Quests.q2e.CompTop);
			--Tracker: complete quest 2e
			MarauderTracker.q2e.check:Show();

		elseif ((msg == "RATKILL") or (msg == "RATKILLPET")) then
			-- Fires each time a player kills a rat (triggered by combat listener);
			local killer = "";
			if (msg == "RATKILL") then
				killer = sender
			elseif (msg == "RATKILLPET") then
				killer = MalVars.ScreenTxt.line0035 .. sender;
			end
			if (MalVars.partyRats < 2) then
				MalVars.partyRats = MalVars.partyRats + 1;
				AddToOverhead(killer .. MalVars.ScreenTxt.line0111 .. "(" .. MalVars.partyRats .. "/2)");
				--Tracker: update quest text for 2f (x/3)
				local qtext = MarauderTracker.q2f.text:GetText();
				--trace("text of q2f retrieved: " .. qtext);
				--Look for pattern of text and (x/4), update with current version of MalVars.partyRats + MalVars.partyFrogs for x
				local critters = MalVars.partyRats + MalVars.partyFrogs
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/4%)", "%1%("..critters.."\/4%)", 1))
				MarauderTracker.q2f.text:SetText(newqtext);
			end
			if ((MalVars.partyRats + MalVars.partyFrogs) == 2) then
				zapMe();
			end
			if ((MalVars.partyRats == 2) and (MalVars.partyFrogs == 2)) then
				--done with killing;
				AddToQuestWindow(MalVars.nJin, "complete", MalVars.Quests.q2f.Title, MalVars.Quests.q2f.CompTop);
				ChatWhisper(MalVars.nJin, MalVars.WhisperTxt.line0091);
				MalVars.checkpoint = 540;
				--Tracker: completed quest 2f
				MarauderTracker.q2f.check:Show();
			end;

		elseif ((msg == "FROGKILL") or (msg == "FROGKILLPET")) then
			-- Fires each time a player kills a rat (triggered by combat listener);
			local killer = "";
			if (msg == "FROGKILL") then
				killer = sender;
			elseif (msg == "FROGKILLPET") then
				killer = MalVars.ScreenTxt.line0035 .. sender;
			end
			if (MalVars.partyFrogs < 2) then
				MalVars.partyFrogs = MalVars.partyFrogs + 1;
				AddToOverhead(killer .. MalVars.ScreenTxt.line0111 .. "(" .. MalVars.partyFrogs .. "/2)");
				--Tracker: update quest text for 2f (x/3)
				local qtext = MarauderTracker.q2f.text:GetText();
				--trace("text of q2f retrieved: " .. qtext);
				--Look for pattern of text and (x/4), update with current version of MalVars.partyRats + MalVars.partyFrogs for x
				local critters = MalVars.partyRats + MalVars.partyFrogs
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/4%)", "%1%("..critters.."\/4%)", 1))
				MarauderTracker.q2f.text:SetText(newqtext);
			end
			if ((MalVars.partyRats + MalVars.partyFrogs) == 2) then
				zapMe();
			end
			if ((MalVars.partyRats == 2) and (MalVars.partyFrogs == 2)) then
				--done with killing
				AddToQuestWindow(MalVars.nJin, "complete", MalVars.Quests.q2f.Title, MalVars.Quests.q2f.CompTop);
				ChatWhisper(MalVars.nJin, MalVars.WhisperTxt.line0091);
				MalVars.checkpoint = 540;
				--Tracker: completed quest 2f
				MarauderTracker.q2f.check:Show();
			end;

		elseif (msg == "GODUEL") then
			AddToQuestWindow(MalVars.nApr, "offer", MalVars.Quests.q3a.Title, MalVars.Quests.q3a.OffTop, MalVars.Quests.q3a.OffBot);
			MalVars.checkpoint = 590;
			--Tracker: offer quest 3a
			MarauderTracker.q3a.text:Show();

		elseif (msg == "DUEL") then
			-- Fires each time a player wins a duel (triggered by chat_msg_system listener)
			local pnum = GetNumPartyMembers(); -- GetNumPartyMembers() returns number of OTHERS in the party
			--So for a full party of 5, this number will be 4, but researcher already doesn't count in the fighting, so this number is OK
			--In other words, in a party of 4 players and a researcher, there must be 4 duel victories.
			MalVars.duels = MalVars.duels + 1;
			AddToOverhead(sender .. MalVars.ScreenTxt.line0113 .. "(" .. MalVars.duels .. "/" .. pnum ..")");
			--Tracker: update text for 3a (x/y)
			local qtext = MarauderTracker.q3a.text:GetText();
			--trace("text of q3a retrieved: " .. qtext);
			--Look for pattern of text and (x/y), update with current version of MalVars.duels for x and pnum for y
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/.%)", "%1%("..MalVars.duels.."\/" .. pnum .. "%)", 1))
			MarauderTracker.q3a.text:SetText(newqtext);
			if MalVars.duels == pnum then
				MalVars.checkpoint = 610;
				AddToQuestWindow(MalVars.nApr, "complete", MalVars.Quests.q3a.Title, MalVars.Quests.q3a.CompTop);
				--Tracker: complete 3a
				MarauderTracker.q3a.check:Show();
			end;

		elseif (msg == "DIE") then
			-- A player has found the mage (triggered by ring click near him)
			MalVars.checkpoint = 640;
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q3b.Title, MalVars.Quests.q3b.CompTop);
			--Tracker: complete quest 3b
			MarauderTracker.q3b.check:Show();

		elseif ((msg == "SHARK") and (MalVars.sharked == 0)) then
			-- A player was killed by the shark (message triggered by combat listener)
			MalVars.sharked = 1;
			MalVars.checkpoint = 670;
			AddToOverhead("\194\161" .. sender .. MalVars.ScreenTxt.line0115);
			--And this overhead message triggers completion of q3c

		elseif (msg == "CUT2") then
			-- WUM clicked second time, play cutscene 2
			MalVars.checkpoint = 680;
			transition201Handler();

		elseif (msg == "SPELL") then
			-- A party member clicks the ring to transfer the spell to Aladriaa
			AddToQuestWindow(MalVars.nAla, "complete", MalVars.Quests.q3e.Title, MalVars.Quests.q3e.CompTop);
			MalVars.checkpoint = 750;
			--Tracker: complete quest 3e
			MarauderTracker.q3e.check:Show();
		end;


	--##############################################################
	--Player-initiated messages to researcher (driven by events)
	--##############################################################


	elseif ((prefix == "SC2Rv1") and (MalVars.isRes == 1)) then --> came from players sent to researcher for reporting
	--trace("received report from player: " .. msg);
		MalVars.pName1 = GetUnitName("party1");
		MalVars.pName2 = GetUnitName("party2");
		MalVars.pName3 = GetUnitName("party3");
		if GetNumPartyMembers == 4 then
			MalVars.pName4 = GetUnitName("party4"); --may not always have a full group
			--trace("4 other group members: " .. pname1 .. pname2 .. pname3 .. pname4);
		elseif GetNumPartyMembers == 3 then
			--trace("3 other group members: " .. pname1 .. pname2 .. pname3)
			MalVars.pName4 = nil;
		end;

		if (string.find(msg, "Status") ~= nil) then
			--print out the status report received from the player in response to the /SC status command
			--trace("recieved a status report, should be printing out");
			--these are al for the researcher, no translation
			trace(msg);

		elseif (msg == "LOADED") then
			--report the successful loading of the MarauderParticipant addon
			trace("|cffff8000" .. sender .. "|r successfully initialized MalParticipant to begin logging");

		elseif (msg == "LOADEDALREADY") then
			trace("|cffff8000" .. sender .. "|r already initialized MalParticipant");

		elseif (msg == "WHISP1") then
			trace("|cffff8000" .. sender .. "|r clicked the ring and got the sound check message");

		elseif (msg == "WHISP2") then
			trace("|cffff8000" .. sender .. "|r clicked the quest book for the first time");

		elseif (msg == "RPT") then
			trace("|cffff8000" .. sender .. "|r appears to be repeating the quest on this account");

		elseif (msg == "LIB") then
			trace("|cffff8000" .. sender .. "|r clicked the Librarian and got quest.");

		--echo whispers from merchants to researcher, no translation
		elseif (msg == "MERCH1") then
			print("|cffff8000" .. sender .. "|r got the clue from Jepetto in The Wonderworks (symmetry)");

		elseif (msg == "MERCH2") then
			print("|cffff8000" .. sender .. "|r got the clue from Karandonna in The Threads of Fate (skies)");

		elseif (msg == "MERCH3") then
			print("|cffff8000" .. sender .. "|r got the clue from Amisi in The Legerdemain Lounge (fire and light)");


		-- ######TABARD VOTING#####################
		--These traces are all for the researcher only, so no translation
		--trace("received vote from player");
		elseif msg == "T01" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 1");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				--trace(pname .. ":" .. sender);
				if (pname == sender) then --this is the party member sending the vote
					if i == 1 then -- player party1 sends Vote1
						MalVars.vote1 = 1 --record a vote for tabard 1 from player 1
					elseif i == 2 then
						MalVars.vote2 = 1 --record a vote for tabard 1 from player 2
					elseif i == 3 then
						MalVars.vote3 = 1 --record a vote for tabard 1 from player 3
					elseif i == 4 then
						MalVars.vote4 = 1 --record a vote for tabard 1 from player 4
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T02" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 2");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 2
					elseif i == 2 then
						MalVars.vote2 = 2
					elseif i == 3 then
						MalVars.vote3 = 2
					elseif i == 4 then
						MalVars.vote4 = 2
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T03" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 3");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 3
					elseif i == 2 then
						MalVars.vote2 = 3
					elseif i == 3 then
						MalVars.vote3 = 3
					elseif i == 4 then
						MalVars.vote4 = 3
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T04" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 4");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 4
					elseif i == 2 then
						MalVars.vote2 = 4
					elseif i == 3 then
						MalVars.vote3 = 4
					elseif i == 4 then
						MalVars.vote4 = 4
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T05" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 5");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 5
					elseif i == 2 then
						MalVars.vote2 = 5
					elseif i == 3 then
						MalVars.vote3 = 5
					elseif i == 4 then
						MalVars.vote4 = 5
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T06" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 6");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 6
					elseif i == 2 then
						MalVars.vote2 = 6
					elseif i == 3 then
						MalVars.vote3 = 6
					elseif i == 4 then
						MalVars.vote4 = 6
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T07" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 7");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 7
					elseif i == 2 then
						MalVars.vote2 = 7
					elseif i == 3 then
						MalVars.vote3 = 7
					elseif i == 4 then
						MalVars.vote4 = 7
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T08" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 8");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 8
					elseif i == 2 then
						MalVars.vote2 = 8
					elseif i == 3 then
						MalVars.vote3 = 8
					elseif i == 4 then
						MalVars.vote4 = 8
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T09" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 9");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 9
					elseif i == 2 then
						MalVars.vote2 = 9
					elseif i == 3 then
						MalVars.vote3 = 9
					elseif i == 4 then
						MalVars.vote4 = 9
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T10" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 10");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 10
					elseif i == 2 then
						MalVars.vote2 = 10
					elseif i == 3 then
						MalVars.vote3 = 10
					elseif i == 4 then
						MalVars.vote4 = 10
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T11" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 11");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 11
					elseif i == 2 then
						MalVars.vote2 = 11
					elseif i == 3 then
						MalVars.vote3 = 11
					elseif i == 4 then
						MalVars.vote4 = 11
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		elseif msg == "T12" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 12");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						MalVars.vote1 = 12
					elseif i == 2 then
						MalVars.vote2 = 12
					elseif i == 3 then
						MalVars.vote3 = 12
					elseif i == 4 then
						MalVars.vote4 = 12
					end;
				end;
			end;
			tallyVotes(MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4);
		-- ##########END OF VOTING##################

		elseif (msg == "END") then
			--status to researcher, no translation
			trace("|cffff8000" .. sender .. "|r reached the end of the quest.");
		end
	end

	--=============================
	--Here is the poll response code taken from Marauder Participant, altered...
	--=============================

	if (channel == "WHISPER") then
		local player = GetUnitName("player")

		if (prefix == "test") then
			local output = player .. "'s logger is enabled, v" .. MalVars.version .. "."
			if (MalVars.initializedParticipant == 1) then
				MsendToResearcherLogger(output, "status")
			end


		elseif ((prefix == "poll") and (MalVars.listeners ~= 1)) then
		--print("Received a poll message from " .. sender)

			if ((MalVars.isRes == 1) and (IsInGuild() == 1)) then
				--researcher receives the poll message sent to himself, forwards to his own guild observers, specifically Aladriaa
				--did this rather than having to mess with ScribeResearcher to also send in GUILD
				SendAddonMessage("pollfwd", msg, "GUILD")
			end


			--code below I want to print only once to the log so I will send after the first poll is received
			if (MalVars.firstPollReceived == 0) then
			--print("MalVars.firstPollReceived was 0, so entered the stats section")

				--getting snapshot of player demographics and stats
				--UnitName
				local name = GetUnitName("Player")
				--print("name: "..name)

				--UnitRace
				local race = UnitRace("Player")
				--print("race: "..race)

				--UnitClass
				local class = UnitClass("Player")
				--print("class: "..class)

				--UnitSex
				local sex = UnitSex("Player")
				--print("sex: "..sex)
				local gender = ""
				if sex == 3 then
					gender = "female"
				elseif sex == 2 then
					gender = "male"
				elseif sex == 1 then
					gender = "Unknown"
				end
				--print("gender: "..gender)

				MalVars.money = GetMoney()
				--print("money: "..MalVars.money)

				local output = "STATS#" .. GetUnitName("Player") .. "#race=" .. race .. "#class=" .. class .. "#gender=" .. gender ..  "\r"
				--print(output)
				if (MalVars.isRes == 1) then
					SendAddonMessage("stats", output, "WHISPER", GetUnitName("player"))
				elseif (MalVars.initializedParticipant == 1) then
					MsendToResearcherLogger(output, "stats")
				end
				--print("stats: " .. output)

				-------------------Create bag status #1--------------------------
				--create array used to store items from all bags, need item and #

				-- determining number of bags the player has
				local numBags = 0
				for i = 0, NUM_BAG_SLOTS do
					local name = GetBagName(i)
					if name ~= nil then
						numBags = numBags + 1
					end
				end

				--for each bag, get number of slots, go through each slot and save off itemId and number to bagItemsBefore{}
				for bag = 0, numBags-1 do
					local numSlots = GetContainerNumSlots(bag)

					--filling idTable with unique id values from slots in bags
					for slot = 1, numSlots do

						local id = GetContainerItemID(bag, slot)
						if id ~= nil then
							local itemCount = GetItemCount(id)
							local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
							bagItemsBefore[id]=itemCount
						end
					end
				end

				--print out contents originally in bag

				local output = "BS#" .. GetUnitName("Player") .. "#"
				--print("bags: " .. output)
				for k,v in pairs(bagItemsBefore) do
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					output = output .. name .. "#" .. v .. "#"
				end
				output = output .. "\r"
				--print("full bag info: " .. output)

				--sending the output in strings of 255 or less if output > 255
				if (#output > 255) then
					local i = 1
					while i < #output do
						if (i ~= 1) then
							outputPart = string.sub(output, i, i+253)
							--first sent part of message, prepend a % to indicate how to format by ScribeResearcher
							outputPart = "%#" .. outputPart
							i = i + 253
						else
							outputPart = string.sub(output, i, i+255)
							i = i+255
						end

						--local outputPart = string.sub(output, i, i+255)
						--i = i+255
						if (MalVars.isRes == 1) then
							SendAddonMessage("bag", outputPart, "WHISPER", GetUnitName("player"))
						elseif (MalVars.initializedParticipant == 1) then
							MsendToResearcherLogger(outputPart, "bag")
							--self:Print(outputPart)
						end
					end
				else
					if (MalVars.isRes == 1) then
						SendAddonMessage("bag", output, "WHISPER", GetUnitName("player"))
					elseif (MalVars.initializedParticipant == 1) then
						MsendToResearcherLogger(output, "bag")
					end
				end


				--for scanning inventory

				inventorySlots = {
					"AmmoSlot",
					"HeadSlot",
					"NeckSlot",
					"ShoulderSlot",
					"ShirtSlot",
					"ChestSlot",
					"WaistSlot",
					"LegsSlot",
					"FeetSlot",
					"WristSlot",
					"HandsSlot",
					"Finger0Slot",
					"Finger1Slot",
					"Trinket0Slot",
					"Trinket1Slot",
					"BackSlot",
					"MainHandSlot",
					"SecondaryHandSlot",
					"RangedSlot",
					"TabardSlot",
				}

				-- iterating over inventory slots to get ids, used to check and see what item changed in inventory
				for i = 1, #inventorySlots do
					local slotName = inventorySlots[i]
					local id, texture, checkRelic = GetInventorySlotInfo(slotName)
					local itemId = GetInventoryItemID("Player", id)
					if (itemId == nil) then
						itemId = 0
					end
					table.insert(equippedItems, itemId)
				end

				--testing... print out the item IDs for all initially equipped things (confirmed works in v3.2.17)
				--for i = 1, #equippedItems do
					--print(equippedItems[i])
				--end

				MalVars.firstPollReceived = 1
			end

			local facing = GetPlayerFacing()
			local SCzone = GetZoneText("player")
			local SCsubzone = GetSubZoneText("player")
			local SCprintZone = ""
			if (SCsubzone == "") then
				SCprintZone = SCzone;
			else
				SCprintZone = SCsubzone;
			end
			--Add for Spanish version, translate to English zone name for logs
			if ((GetLocale() == "esMX") or (GetLocale() == "esES")) then
				SCprintZone = malTranslate(SCprintZone);
			end
			--print("SCprintZone: "..SCprintZone)

			local speed = GetUnitSpeed("player")
			local movement = ""

			if speed == 7 then
				movement = "Normal running"
			elseif speed == 2.5 then
				movement = "Walking"
			elseif speed == 4.5 then
				movement = "Running backwards"
			elseif speed == 26.6 then
				movement = "Epic flying mount"
			elseif speed == 4.7222199440002 then
				movement = "Swimming"
			elseif speed == 0 then
				movement = "Still"
			else
				movement = "unknown"
			end
			--print("movement: "..movement)

			local unitX, unitY = GetPlayerMapPosition("player")
			local output = "P#" .. msg .. "#" .. GetUnitName("Player") .. "#" .. SCprintZone .. "#" ..tostring(unitX) .. "#" .. tostring(unitY) .. "#0.0#" .. facing .. "#" .. movement .. "\r"
			--for testing:
			--print("output to send in response to poll: "..output)
			if (MalVars.isRes == 1) then
				--to make sure the message is logged even if there's no party yet, since the polls are no longer delayed until "start" is sent
				sendWhisperToResearcherLogger(output)
			elseif (MalVars.initializedParticipant == 1) then
				sendToResearcherLogger(output);
			end
		end
	end
end)



local ChatListenFrame = CreateFrame("Frame");

ChatListenFrame:RegisterEvent("CHAT_MSG_PARTY");
ChatListenFrame:RegisterEvent("CHAT_MSG_PARTY_LEADER");
ChatListenFrame:RegisterEvent("CHAT_MSG_SAY");
ChatListenFrame:RegisterEvent("CHAT_MSG_YELL");
ChatListenFrame:RegisterEvent("CHAT_MSG_WHISPER");
ChatListenFrame:RegisterEvent("CHAT_MSG_WHISPER_INFORM");
ChatListenFrame:SetScript("OnEvent", function(event, ...)

	local eType = select(1, ...); -- eventType
	local msg = select(2, ...); -- message
	local sender = select(3, ...); -- sender
	local lang = select(4, ...); -- language
	local cS = select(5, ...); -- channelString
	local target = select(6, ...); -- target (not always used)
	local eleven = select(11, ...); -- sender? gets zero (documentation says this should be chat lineID)
	local lineID = select(12, ...); -- chat lineID (documentation says this shold be sender GUID)
	--trace("A chat was noticed: " .. eType .. ", " .. msg .. ", " .. sender .. ", " .. eleven .. ", " .. lineID);


	--get rid of upper-case characters for matching
	local str3tosearch = string.find(string.lower(msg), MalVars.code);

	if ((str3tosearch ~= nil) and (MalVars.checkpoint == 390) and ((GetSubZoneText() == MalVars.Zones.violetstand) or (GetSubZoneText() == MalVars.Zones.purpleparlor))) then
		SendAddonMessage("SCv1", "SOLVED", "PARTY");
	end;

	if ((str3tosearch ~= nil) and (MalVars.checkpoint == 420) and (GetSubZoneText() == MalVars.Zones.cantripsandcrows)) then
		SendAddonMessage("SCv1", "AZUKK", "PARTY");
	end;

	if (eType == "CHAT_MSG_SAY") then
		if sender == GetUnitName("Player") then
			local output = "C#" .. GetUnitName("Player") .. "#" .. msg .. "\r"
			if (MalVars.sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", MalVars.nSed);
			else
				MsendToResearcherLogger(output, "chatAndEvents");
			end
		end

	elseif (eType == "CHAT_MSG_YELL") then
		--In 3.2.11, changed to only log if your toon did the yelling
		if (sender == GetUnitName("player")) then
			local output = "Y#" .. sender .. "#yelled " .. msg .. "\r"
			if (MalVars.listeners == 1) then
				--sendToShortGuy(msg, "yell");
				SendAddonMessage("SCSHORTYELL", msg, "WHISPER", MalVars.sourceBaddie);
			else
				MsendToResearcherLogger(output, "chatAndEvents");
				--trace("called MsendToResearcherLogger at Marauder:1563")
			end
		end

	--elseif (eType == "CHAT_MSG_WHISPER") then
		--31JAN2012 decided we don't need to log incoming whispers... only outgoing
		--incoming whispers from players (so the sender is listed first, as the whisper source)
		--local output = "W#" .. sender .. "#" .. msg .. "#" .. UnitName("Player") .. "\r"
		--this event only fires when the player receives a whisper, so no need to check whether target name matches
		--MsendToResearcherLogger(output, "chatAndEvents")
		--trace("called MsendToResearcherLogger at Marauder:1573")

	elseif (eType == "CHAT_MSG_WHISPER_INFORM") then
		--outgoing whispers to other players (so the player is listed first, as the whisper source)
		if target == nil then
			target = " "
		end
		--local numPartyMembers = GetNumPartyMembers()
		--local nonPartyMember = 1
		--for i = 1, numPartyMembers do
			--local participantName = GetUnitName("party" .. i)
			--if (target == participantName) then
				--nonPartyMember = 0
				--break
			--end
		--end

		--if nonPartyMember == 1 then
			local output = "W#" .. GetUnitName("Player") .. "#" .. msg .. "#" .. target .. "\r"
			MsendToResearcherLogger(output, "chatAndEvents")
			--trace("called MsendToResearcherLogger at Marauder:1594")
		--end

	elseif (eType == "CHAT_MSG_PARTY") then
		local output = "PC#" ..  GetUnitName("Player") .. "#" .. msg .. "\r"
		if sender == UnitName("Player") then
			MsendToResearcherLogger(output, "chatAndEvents")
		end
	elseif (eType == "CHAT_MSG_PARTY_LEADER") then
		local output = "PL#" ..  GetUnitName("Player") .. "#" .. msg .. "\r"
		if sender == UnitName("Player") then
			MsendToResearcherLogger(output, "chatAndEvents")
		end
	end
end);

local ZoneUpdateFrame = CreateFrame("Frame");
--to track location for zaps
ZoneUpdateFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
ZoneUpdateFrame:RegisterEvent("ZONE_CHANGED");
ZoneUpdateFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
ZoneUpdateFrame:SetScript("OnEvent", function(event, ...)
	if ((MalVars.rune == 0) and (GetSubZoneText() == MalVars.Zones.runeweaversquare) and (MalVars.initializedParticipant == 1)) then
		zapMe();
		MalVars.rune = 1;
	elseif ((MalVars.dal1 == 0) and (GetSubZoneText() == MalVars.Zones.dalaran) and (MalVars.checkpoint == 305)) then
		rogueSoundLauncher(2);
		MalVars.dal1 = 1;
	elseif ((MalVars.viol == 0) and (GetSubZoneText() == MalVars.Zones.violetcitadel) and (MalVars.initializedParticipant == 1)) then
		zapMe();
		MalVars.viol = 1;
	elseif ((MalVars.und == 0) and (GetSubZoneText() == MalVars.Zones.underbelly) and (MalVars.initializedParticipant == 1)) then
		zapMe();
		MalVars.und = 1;
	elseif ((MalVars.ring == 0) and (GetSubZoneText() == MalVars.Zones.circleofwills) and (MalVars.checkpoint == 490)) then
		rogueSoundLauncher(2);
		MalVars.ring = 1;
	elseif ((SCrpt3 == 0) and (GetSubZoneText() == MalVars.Zones.underbelly) and (MalVars.checkpoint == 790)) then
		rogueSoundLauncher(5);
		SCrpt3 = 1
	end
end)



local EmoteListenFrame = CreateFrame("Frame");
-- Will be used to monitor Chat for emotes (for Azukk)
--NOTE: this is only to listen for the first bad emote, to trigger the Zap cycle
EmoteListenFrame:RegisterEvent("CHAT_MSG_EMOTE");
EmoteListenFrame:RegisterEvent("CHAT_MSG_TEXT_EMOTE");
EmoteListenFrame:SetScript("OnEvent", function(event, ...)
	local eType = select(1, ...); -- eventType
	local msg = select(2, ...); -- message
	local sender = select(3, ...); -- sender
	local four = select(4, ...);
	local five = select(5, ...);
	local six = select(6, ...);
	local seven = select(7, ...);
	local eight = select(8, ...);
	local nine = select(9, ...);
	local ten = select(10, ...);
	local eleven = select(11, ...); -- sender? gets zero (documentation says this should be chat lineID)
	local lineID = select(12, ...); -- chat lineID? gets zero (documentation says this shold be sender GUID)
	--trace("An emote was noticed: eType=" .. eType .. ";msg=" .. msg .. ";sender=" .. sender .. "four=" .. four .. ";five=" .. five .. ";six=" .. six .. ";seven=" .. seven .. ";eight=" .. eight .. ";nine=" .. nine .. ";ten=" .. ten .. ";eleven=" .. eleven .. ", " .. lineID);
	str1tosearch = string.find(msg, MalVars["You flex"]);
	str2tosearch = string.find(msg, MalVars["flexes"]);
	strStosearch = string.find(msg, MalVars["roars with bestial vigor at you"]);
	if ((GetSubZoneText() == MalVars.Zones.violetstand) and (strStosearch ~= nil) and ((GetUnitName("Player") == MalVars.nSed) or (GetUnitName("Player") == "Padagenx"))) then
		--this should be Seddrik hearing the assassin at the beginning, triggering rogue sound and overhead text
		SendAddonMessage("SRv1", "ASSASSIN", "PARTY")
		--and for testing, do this locally too
		rogueSoundLauncher(0);
	elseif ((MalVars.checkpoint == 450) and (GetSubZoneText() == MalVars.Zones.cantripsandcrows) and (closeEnough(0.02, 0.3760, 0.6040)) and (str1tosearch ~= nil) and (UnitInParty(sender))) then
		ChatWhisper(MalVars.nAzu, MalVars.ScreenTxt.line0108a);
		AddToOverheadQuick(MalVars.ScreenTxt.line0108a);
		SendAddonMessage("SCv1", "EMOTED", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "performed the correct emote\r";
		MsendToResearcherLogger(output, "chatAndEvents"); -- send to researcher log as well
		MalVars.checkpoint = 460; -- so that, once a player does the right one and gets a whisper, they won't get the error message again
	elseif ((MalVars.checkpoint == 450) and (GetSubZoneText() == MalVars.Zones.cantripsandcrows) and (closeEnough(0.02, 0.3760, 0.6040)) and (str2tosearch ~= nil) and (UnitInParty(sender))) then
		--do nothing if you hear someone else do the flex
	elseif ((MalVars.checkpoint == 450) and (GetSubZoneText() == MalVars.Zones.cantripsandcrows) and (closeEnough(0.02, 0.3760, 0.6040)) and (UnitInParty(sender))) then
		--for each incorrect emote
		AddToOverheadQuick(MalVars.ScreenTxt.line0108);
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "performed the wrong emote\r";
		MsendToResearcherLogger(output, "chatAndEvents"); -- send to researcher log as well
	end;

	--every time the local character performs an emote
	if (sender == GetUnitName("Player")) then

		if (eType == "CHAT_MSG_TEXT_EMOTE") then
			--print("should send log about E#")
			local output = "E#" .. GetUnitName("Player") .. "#" .. msg .. "\r";
			if (MalVars.initializedParticipant == 1) then
				MsendToResearcherLogger(output, "chatAndEvents");
			elseif (MalVars.listeners == 1) then
				--sendToShortGuy(msg, "emo") -- going to GUILD via SendAddonMessage
				SendAddonMessage("SCSHORTEMO", output, "WHISPER", MalVars.sourceBaddie)
			elseif (MalVars.sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", MalVars.nSed);
			end

		elseif (eType == "CHAT_MSG_EMOTE") then
			--print("should send log about CE#")
			local output = "CE#" .. GetUnitName("Player") .. "#" .. msg .. "\r";
			if (MalVars.initializedParticipant == 1) then
				MsendToResearcherLogger(output, "chatAndEvents");
			elseif (MalVars.listeners == 1) then
				--sendToShortGuy(msg, "custemo") -- going to GUILD via SendAddonMessage
				SendAddonMessage("SCSHORTCUSTEMO", output, "WHISPER", MalVars.sourceBaddie)
			elseif (MalVars.sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", MalVars.nSed);
			end
		end

	end;

end);

--==========================================
--Combat Log parser function
--==========================================

local CombatListenFrame = CreateFrame("Frame");
--trace("created frame");
--CombatFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent");
CombatListenFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
--trace("registered");
--CombatFrame:SetScript("OnEvent", function(timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, destinationGUID, destinationName, destinationFlags, ...)
CombatListenFrame:SetScript("OnEvent", function(event, ...)
	local output = ""
	local i = 0
	local j = 0
	--trace("A CombatLogEvent occurred: " .. timestamp .. ", " .. eventType .. ", " .. tostring(hideCaster) .. ", " .. tostring(sourceGUID) .. ", " .. sourceFlags .. ", " .. destinationFlags .. ", " .. tostring(destinationGUID) .. ", " .. destinationName);
	local ev = select(1, ...); -- (event) [parameter 0]
	local ts = select(2, ...); -- timestamp [parameter 1]
	local eT = select(3, ...); -- eventType [parameter 2]
	local hC = select(4, ...); -- hideCaster [parameter 3]
	local sG = select(5, ...); -- sourceGUID [parameter 4]
	local sN = select(6, ...); -- sourceName [parameter 5]
	local sF = select(7, ...); -- sourceFlags [parameter 6]
	local sF2 = select(8, ...); -- sourceFlags2 [parameter 7, added in 4.2]
	local dG = select(9, ...); -- destGUID [parameter 8, shifted as of 4.2]
	local dN = select(10, ...); -- destName [parameter 9, shifted as of 4.2]
	local dF = select(11, ...); -- destFlags [parameter 10, shifted as of 4.2]
	local dF2 = select(12, ...); --destFlags2 [parameter 11, added in 4.2]
	local param12 = select(13, ...); -- parameter 12
	local param13 = select(14, ...); -- parameter 13
	local param14 = select(15, ...); -- parameter 14
	local param15 = select(16, ...); -- parameter 15
	local param16 = select(17, ...); -- parameter 16
	--trace("A CombatLogEvent occurred: " .. ts .. ", " .. eT .. ", " .. tostring(hC) .. ", " .. tostring(sG) .. ", " .. sF .. ", " .. dF .. ", " .. tostring(dG) .. ", " .. dN);

	--Seddrick's death at the beginning
	--Now (3.1.9) use this as a trigger rather than the old KILL button
	-- Only trigger with the first hit
	--As of 3.2.5, remove the variable update and Overhead screen text from automatic triggering in combat
	--   Will be tied to a macro that plays the stealth sound and then displays the overhead
	--if (((eT == "SWING_DAMAGE") or (eT == "SPELL_DAMAGE")) and (MalVars.checkpoint == 70) and ((dN == "Seddrik") or (dN == "Sedrick"))) then
		--trace(eT .. ": " .. sN .. " damaged " .. dN)
	--end

	--trace("A combat log event occurred: source GUID " .. sG);
	--record the last damage-dealer, to determine whether a kill was done by a player or a pet
	if (((eT == "SWING_DAMAGE") or (eT == "SPELL_DAMAGE")) and ((dN == MalVars.Critters.rabbit) or (dN == MalVars.Critters.squirrel) or (dN == MalVars.Critters.underbellyrat) or (dN == MalVars.Critters.sewerfrog))) then
		--trace(eT .. ": " .. sN .. " damaged " .. dN)
		MalVars.LastDamager = sG
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
	end

	--squirrel kill by player
	if ((eT == "PARTY_KILL") and (dN == MalVars.Critters.squirrel) and (sG == UnitGUID("player")) and (MalVars.checkpoint >= 140)) then
		--trace("I killed a squirrel");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "SQUIRRELKILL", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "killed a squirrel\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == MalVars.Critters.squirrel) and (MalVars.LastDamager == UnitGUID("pet")) and (UnitGUID("pet") ~= "0x0000000000000000") and (MalVars.checkpoint >= 140)) then
		--trace("My pet killed a squirrel");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "SQUIRRELKILLPET", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "pet killed a squirrel\r";
		sendToResearcherLogger(output);

	--bunny kill
	elseif ((eT == "PARTY_KILL") and (dN == MalVars.Critters.rabbit) and (sG == UnitGUID("player")) and (MalVars.checkpoint >= 140)) then
		--trace("I killed a bunny");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "BUNNYKILL", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "killed a rabbit\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == MalVars.Critters.rabbit) and (MalVars.LastDamager == UnitGUID("pet")) and (UnitGUID("pet") ~= "0x0000000000000000") and (MalVars.checkpoint >= 140)) then
		--trace("My pet killed a bunny");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "BUNNYKILLPET", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "pet killed a rabbit\r";
		sendToResearcherLogger(output);

	--rat kill
	elseif ((eT == "PARTY_KILL") and (dN == MalVars.Critters.underbellyrat) and (sG == UnitGUID("player")) and (MalVars.checkpoint == 530)) then
		--trace("I killed a rat");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "RATKILL", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "killed a rat\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == MalVars.Critters.underbellyrat) and (MalVars.LastDamager == UnitGUID("pet")) and (UnitGUID("pet") ~= "0x0000000000000000") and (MalVars.checkpoint == 530)) then
		--trace("My pet killed a rat");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "RATKILLPET", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "pet killed a rat\r";
		sendToResearcherLogger(output);

	--frog kill
	elseif ((eT == "PARTY_KILL") and (dN == MalVars.Critters.sewerfrog) and (sG == UnitGUID("player")) and (MalVars.checkpoint == 530)) then
		--trace("I killed a frog");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "FROGKILL", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "killed a frog\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == MalVars.Critters.sewerfrog) and (MalVars.LastDamager == UnitGUID("pet")) and (UnitGUID("pet") ~= "0x0000000000000000") and (MalVars.checkpoint == 530)) then
		--trace("My pet killed a frog");
		--trace("eT: " .. eT .. "; sG: " .. sG .. "; dN: " .. dN);
		SendAddonMessage("SCv1", "FROGKILLPET", "PARTY");
		local output = "FB#" .. GetUnitName("Player") .. "#" .. "pet killed a frog\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and ((dN == MalVars.Critters.rabbit) or (dN == MalVars.Critters.squirrel) or (dN == MalVars.Critters.underbellyrat) or (dN == MalVars.Critters.sewerfrog)) and (MalVars.checkpoint >= 530)) then
		--trace(dN .. " died, but didn't hit on my conditions: source GUID " .. sG)

	--shark kill (doesn't ID shark, but it's a sanctuary an no aggro NPCs.. so unlikely to die there any other way)
	elseif ((eT == "UNIT_DIED") and (dN == GetUnitName("player")) and (MalVars.checkpoint == 660)) then
		--trace("got killed");
		SendAddonMessage("SCv1", "SHARK", "PARTY");
		local output = "D#" .. GetUnitName("player") .. "\r";
		MsendToResearcherLogger(output, "chatAndEvents")

	elseif ((eT == "UNIT_DIED") and ((dN == "Izuna") or (dN == "Izunai"))) then
		--log Izu's death for coordinating party and off-faction log timestamps (Izu logs the PLAYER_DIED event)
		local output = "D#" .. dN .. "\r";
		if (MalVars.initializedParticipant == 1) then
			MsendToResearcherLogger(output, "chatAndEvents")
		elseif
			(MalVars.listeners == 1) then
			sendToOffFacResearcherLogger(output, "chatAndEvents", MalVars.sourceBaddie)
		end
	end

	--by default.. added this initialization in version 4.1
	MalVars.detail1set = 0;
	MalVars.detail2set = 0;

	---Take subevent and strip prefix---
	---If prefix contains range, spell, spell_periodic, spell_building, then get 13th parameter
	i, j = string.find(eT, "RANGE")
	if (i ~= nil) then
		MalVars.detail1 = param13
		MalVars.detail1set = 1
		--print("detail1_RANGE: " .. "X" .. detail1 .. "X")
	end

	i, j = string.find(eT, "SPELL")
	if (i ~= nil) then
		MalVars.detail1 = param13
		MalVars.detail1set = 1
		--print("detail1_SPELL: " .. "X" .. detail1 .. "X")
	end

	---If prefix contains environmental get 12th parameter
	i, j = string.find(eT, "ENVIRONMENTAL")
	if (i ~= nil) then
		MalVars.detail1 = param12
		MalVars.detail1set = 1
		--print("detail1_ENVIRONMENTAL: " .. "X" .. detail1 .. "X")
	end

	---If suffix contains "AURA" but not "AURA_BROKEN_SPELL" then get 15th parameter
	i, j = string.find(eT, "AURA")
	if ((i ~= nil) and (j == 4)) then
		MalVars.detail2 = param15
		MalVars.detail2set = 1
		--print("detail2_AURA: " .. "X" .. detail2 .. "X")
	end

	---If suffix contains "AURA_BROKEN_SPELL" then get 16th parameter
	i, j = string.find(eT, "AURA_BROKEN_SPELL")
	if (i ~= nil) then
		MalVars.detail2 = param16
		MalVars.detail2set = 1
		--print("detail2_AURA_BROKEN_SPELL: " .. "X" .. detail2 .. "X")
	end

	---If suffix contains "INTERRUPT", "DISPEL", "DISPEL_FAILED", "STOLEN" then get 16th parameter
	i, j = string.find(eT, "INTERRUPT")
	if (i ~= nil) then
		MalVars.detail2 = param16
		MalVars.detail2set = 1
		--print("detail2_INTERRUPT: " .. "X" .. detail2 .. "X")
	end

	i, j = string.find(eT, "DISPEL")
	if (i ~= nil) then
		MalVars.detail2 = param16
		MalVars.detail2set = 1
		--print("detail2_DISPEL: " .. "X" .. detail2 .. "X")
	end

	i, j = string.find(eT, "DISPEL_FAILED")
	if (i ~= nil) then
		MalVars.detail2 = param16
		MalVars.detail2set = 1
		--print("detail2_DISPEL_FAILED: " .. "X" .. detail2 .. "X")
	end

	i, j = string.find(eT, "STOLEN")
	if (i ~= nil) then
		MalVars.detail2 = param16
		MalVars.detail2set = 1
		--print("detail2_STOLEN: " .. "X" .. detail2 .. "X")
	end

	if (MalVars.detail1set == 0) then
		MalVars.detail1 = nil
	end

	if (MalVars.detail2set == 0) then
		MalVars.detail2 = nil
	end

	--#######Getting when player is  attacking######################
	if (sN == GetUnitName("Player")) then

		if (dN == nil) then
			dN = "unknown"
		end
		local output = "";
		if ((MalVars.detail1 ~= nil) and (MalVars.detail2 ~= nil)) then
			output = "CB#" .. sN .. "#" .. eT .. "#" .. MalVars.detail1 .. "#" .. MalVars.detail2 .. "#" ..  dN ..  "\r"
		elseif (MalVars.detail1 ~= nil)  then
			output = "CB#" .. sN .. "#" .. eT .. "#" .. MalVars.detail1 .. "#" .. dN .. "\r"
		elseif (MalVars.detail2 ~= nil) then
			output = "CB#" .. sN .. "#" .. eT .. "#" ..  MalVars.detail2 .. "#"  .. dN .. "\r"
		end

		--print("Player is attacking, should be sending using MsendToResearcherLogger with output=" .. output)
		if (MalVars.initializedParticipant == 1) then
			MsendToResearcherLogger(output, "chatAndEvents")
		elseif (MalVars.sameFacMsg == 1) then
			SendAddonMessage("log", output, "WHISPER", MalVars.nSed);
		--elseif (MalVars.listeners == 1) then
			--sendToOffFacResearcherLogger(output, "chatAndEvents", MalVars.sourceBaddie)
		else
			--print("didn't find anyone to send log message to, Marauder.lua line 1930");
		end
	end


	--#####Getting when the player is attacked##########################
	if (dN ~= nil) then
		if dN == GetUnitName("Player") then
			--adding to get around "attempt to concatenate local 'sourceName' (a nil value) error gotten
			--sometimes when toon dies
			if (sN == nil) then
				sN =  "unknown"
			end
			local output = "";
			if ((MalVars.detail1 ~= nil) and (MalVars.detail2 ~= nil)) then
				output = "CB#" .. sN .. "#" .. eT .. "#" .. MalVars.detail1 .. "#" .. MalVars.detail2 .. "#" ..  dN ..  "\r"
			elseif (MalVars.detail1 ~= nil)  then
				output = "CB#" .. sN .. "#" .. eT .. "#" .. MalVars.detail1 .. "#" .. dN .. "\r"
			elseif (MalVars.detail2 ~= nil) then
				output = "CB#" .. sN .. "#" .. eT .. "#" ..  MalVars.detail2 .. "#"  .. dN .. "\r"
			end
			--SendAddonMessage("log", output, "PARTY")

			--print("Player being attacked, should be sending using MsendToResearcherLogger with output=" .. output)
			if (MalVars.initializedParticipant == 1) then
				MsendToResearcherLogger(output, "chatAndEvents")
			elseif (MalVars.sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", MalVars.nSed);
			--elseif (MalVars.listeners == 1) then
				--sendToOffFacResearcherLogger(output, "chatAndEvents", MalVars.sourceBaddie)
			else
				--print("didn't find anyone to send log message to, Marauder.lua line 1961");
			end
		end
	end

end); --of the CombatFrame script


local SystemMsgFrame = CreateFrame("Frame");
--for Duels and Trading notices
SystemMsgFrame:RegisterEvent("CHAT_MSG_SYSTEM");
SystemMsgFrame:SetScript("OnEvent", function(event, ...)

	local msg = select(2, ...);

	if (string.find(msg, "ha vencido")) then
		--Spanish client
		local winner = string.gsub(msg, "(.*) ha vencido (.*) en un duelo", "%1", 1);
		local loser = string.gsub(msg, "(.*) ha vencido (.*) en un duelo", "%2", 1);
		--print(winner .. " has defeeted " .. loser .. " in a duelicious duel");
		if ((winner == GetUnitName("player")) and (MalVars.duelWon == 0) and (MalVars.checkpoint == 600)) then
			--trace("sent DUEL message");
			SendAddonMessage("SCv1", "DUEL", "PARTY");
			local output = "FB#" .. GetUnitName("Player") .. "#" .. "beat" .. loser .. " in a duel\r";
			sendToResearcherLogger(output);
			MalVars.duelWon = 1; -- the winning player sets this variable locally
		end;
	elseif (string.find(msg, "has defeated")) then
		--English client
		local winner = string.gsub(msg, "(.*) has defeated (.*) in a duel", "%1", 1);
		local loser = string.gsub(msg, "(.*) has defeated (.*) in a duel", "%2", 1);
		--print(winner .. " has defeeted " .. loser .. " in a duelicious duel");
		if ((winner == GetUnitName("player")) and (MalVars.duelWon == 0) and (MalVars.checkpoint == 600)) then
			--trace("sent DUEL message");
			SendAddonMessage("SCv1", "DUEL", "PARTY");
			local output = "FB#" .. GetUnitName("Player") .. "#" .. "beat" .. loser .. " in a duel\r";
			sendToResearcherLogger(output);
			MalVars.duelWon = 1; -- the winning player sets this variable locally
		end;
	end;
end); --of the SystemMsgFrame script

-- #######################################################
-- World Map display function (removed)
-- #######################################################

--local MapEventFrame = CreateFrame("Frame");
--MapEventFrame:RegisterAllEvents();
--MapEventFrame:RegisterEvent("WORLD_MAP_UPDATE");
--MapEventFrame:SetScript("OnEvent", function(self, event, ...)

	--if WorldMapFrame:IsShown() == 1 then
		--if (SCworldMapAutoToggle == "0") then
			--print("World Map shown")
			--local output = "FB#" .. UnitName("Player") .. "#" .. "displayed map\r";
			--sendToResearcherLogger(output);
		--end
	--end
--end)


-- #######################################################
-- OnLoad function
-- #######################################################
function handleOnLoad(self)
	trace("");
	trace("|cffff8000Maleante|r: Maleante cargado");
	trace(" ");
	-- Setup events
	self:RegisterEvent('VARIABLES_LOADED');
	self:RegisterEvent("MERCHANT_SHOW");
	self:RegisterEvent("MERCHANT_CLOSED");
	self:RegisterEvent("MERCHANT_UPDATE");
	self:RegisterEvent("ITEM_PUSH");
	self:RegisterEvent("CHAT_MSG_LOOT");
	self:RegisterEvent("CHAT_MSG_TRADESKILLS");
	self:RegisterEvent("TRADE_SHOW");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("PLAYER_DEAD");
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	self:RegisterEvent("UNIT_TARGET");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_LOGOUT");
	self:RegisterEvent("BAG_UPDATE");

end
-- #######################################################

-- #######################################################
-- Event handlers
-- #######################################################
function handleOnEvent(self, event, ...)
	--trace("Marauder: handleOnEvent event = " .. event);

	if ((event == "MERCHANT_UPDATE") and (MalVars.initializedParticipant == 1)) then
		--self:Print(event)
		MalVars.merchantUpdate = 1
	end

	if ((event == "ITEM_PUSH") and (MalVars.initializedParticipant == 1)) then
		MalVars.itemPush = 1
		--self:Print(event)
	end

	--SRL 4.1 fixed this piece, which had never worked, but loggers didn't expect it. Disabling for now.
        --Instead of commenting this out, moved the 2nd condition to 2, which won't ever hit. To re-enable this clause, set it back to 1
	if ((event == "CHAT_MSG_LOOT") and (MalVars.initializedParticipant == 2)) then
		local msg = select(1, ...)
		--print("CHAT_MSG_LOOT fired: " .. msg);
		--self:Print(event)
		local array msgArray = {strsplit("[", msg)}
		local cleanedLootArray = {strsplit("]", msgArray[2])}
		--if MalVars.playerMoney and MalVars.itemPush fire before this then there was a purchase
		if (MalVars.playerMoney == 1 and MalVars.itemPush == 1 and MalVars.merchantUpdate == 1) then
			MalVars.playerMoney = 0
			MalVars.itemPush = 0
			MalVars.merchantUpdate = 0
			local output = "PR#" ..  GetUnitName("Player") .. "#" .. cleanedLootArray[1] .. "\r"
			MsendToResearcherLogger(output, "chatAndEvents")
			--self:Print(output)
		end
	end

	if ((event == "CHAT_MSG_TRADESKILLS") and (MalVars.checkpoint == 285)) then
		local msg = select(1, ...);
		--print("CHAT_MSG_TRADESKILLS fired: " .. msg);
		--local crafted = string.match(msg, "Creas Barra de cobre");
		--if (crafted ~= nil) then
		--	--trace("congrats on the " .. crafted .."!");
		--	SendAddonMessage("SCv1", "COPPER", "PARTY");
		--end

		if (string.find(msg, "Creas Barra de cobre")) then
			--Spanish client
			--trace("matched copper crafting in Spanish")
			SendAddonMessage("SCv1", "COPPER", "PARTY");
		elseif (string.find(msg, "You create (Copper Bar)")) then
			--English client
			--trace("matched copper crafting in English")
			SendAddonMessage("SCv1", "COPPER", "PARTY");
		end
	end

	if ((event == "TRADE_SHOW") and (MalVars.initializedParticipant == 1)) then
		local thatguy, thang = UnitName("NPC")
		local output = "TRDReq#" .. GetUnitName("player") .. "#" .. thatguy .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents");
	end

	if ((event == "PLAYER_MONEY") and (MalVars.initializedParticipant == 1)) then
		MalVars.playerMoney=1
		local origMoney = MalVars.money
		MalVars.money = GetMoney()
		local diffMoney = MalVars.money - origMoney
		if (diffMoney ~= 0) then
			local output = "BU#" .. GetUnitName("Player") .. "#copper#" .. diffMoney .. "\r"
			MsendToResearcherLogger(output, "chatAndEvents")
		end
		--self:Print(output)
	end

	if ((event == "PLAYER_EQUIPMENT_CHANGED") and (MalVars.initializedParticipant == 1)) then
		local slot = select(1, ...)
		local hasItem = select(2, ...)

		--hasItem would be 1 if putting on item
		if hasItem == 1 then

			local equippedItemId = equippedItems[slot + 1]
			if (equippedItemId > 0) then
				local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(equippedItemId)
				local output = "UE#" .. GetUnitName("Player") .. "#" .. name .. "\r"
				--SendAddonMessage("log", output, "PARTY")
				MsendToResearcherLogger(output, "chatAndEvents")
				--self:Print(output)
			end

			--update equippedItems table
			local id = GetInventoryItemID("Player", slot)
			--table.insert(equippedItems, slot + 1, id)
			equippedItems[slot+1] = id
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
			local output = "EQ#" .. GetUnitName("Player") .. "#" .. name .. "\r"
			--SendAddonMessage("log", output, "PARTY")
			MsendToResearcherLogger(output, "chatAndEvents")
			--self:Print(output)
		else
			local id = equippedItems[slot + 1]
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
			local output = "UE#" .. GetUnitName("Player") .. "#"  .. name .. "\r"
			equippedItems[slot + 1]=0
			--SendAddonMessage("log", output, "PARTY")
			MsendToResearcherLogger(output, "chatAndEvents")
			--self:Print(output)
		end
	end

	if ((event == "UNIT_TARGET") and (MalVars.initializedParticipant == 1)) then
		local unitID = select(1, ...)
		local name = GetUnitName("target")
		--adding to get around "attempt to concatenate local 'name' (a nil value) error gotten
		--sometimes when using UnitName("mouseover") to get name of NPC
		if (name ~= nil) then
			if (GetUnitName(unitID) == GetUnitName("Player")) then
				local output = "TGT#" .. GetUnitName(unitID) .. "#" .. name .. "\r"
				MsendToResearcherLogger(output, "chatAndEvents")
			end
		end
	end

	if ((event == "PLAYER_REGEN_ENABLED") and (MalVars.initializedParticipant == 1)) then
		--SRL changed tag name from RegenON to OutComb for easier analysis = out of combat
		local output = "OutComb#" .. GetUnitName("Player") .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents")
	end

	if ((event == "PLAYER_REGEN_DISABLED") and (MalVars.initializedParticipant == 1)) then
		--SRL changed tag name from RegenOFF to InComb for easier analysis = in combat
		local output = "InComb#" .. GetUnitName("Player") .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents")
	end

	if ((event == "PLAYER_LOGOUT") and (MalVars.initializedParticipant == 1)) then
		--self:Print(event)
		local output = "L#" .. GetUnitName("Player") .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents")
	end

	if (event == 'VARIABLES_LOADED') then
		--setupInterfaceMenu();
		setupSlashCommands();
		setupGuildVariables();
		--iniStates();
	end

	--=====================================
	-- BAG Update
	--=====================================

	if ((event == "BAG_UPDATE") and (MalVars.initializedParticipant == 1)) then
		--self:Print(event .. " " .. bagID)
		MalVars.count = MalVars.count + 1
		local output= ""
		-------------------Create bag status #2--------------------------
		--create array used to store items from all bags, need item and #

		-- determining number of bags the player has
		local numBags = 0
		for i = 0, NUM_BAG_SLOTS do
			local name = GetBagName(i)
			if name ~= nil then
				numBags = numBags + 1
			end
		end

		MtableDelete(bagItemsAfter)
		--for each bag, get number of slots, go through each slot and save off itemId and number to bagItemsBefore{}
		for bag = 0, numBags-1 do
			local numSlots = GetContainerNumSlots(bag)

			--filling idTable with unique id values from slots in bags
			for slot = 1, numSlots do

				local id = GetContainerItemID(bag, slot)
				if id ~= nil then
					local itemCount = GetItemCount(id)
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
					--self:Print(bag .. ", " .. slot .. ", " .. id .. ", " .. name .. ", " .. itemCount)
					bagItemsAfter[id]=itemCount
				end
			end
		end

		--count the number of items in bagItemsAfter
		local bagItemsAfterItemsNo = 0
		for k,v in pairs(bagItemsAfter) do
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
			bagItemsAfterItemsNo = bagItemsAfterItemsNo + 1
		end

		--count the number of items in bagItemsBefore
		local bagItemsBeforeItemsNo = 0
		for k,v in pairs (bagItemsBefore) do
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
			bagItemsBeforeItemsNo = bagItemsBeforeItemsNo + 1
		end


		--self:Print("count " .. MalVars.count .. "bagB4#: " .. bagItemsBeforeItemsNo .. " " .. "bagAfter#: " .. bagItemsAfterItemsNo)
		--self:Print("----------------------------------------------------")
		-----------------------------------------------------------------


		--iterate over bagItemsAfter and compare itemCount between both bags
		if (bagItemsAfterItemsNo == bagItemsBeforeItemsNo) then
			--self:Print("in here")
			for k,v in pairs(bagItemsAfter) do
				--12/20 had to add the bagItemsBefore[k] clause in case the number of items in each bag is the same but items were switched so that
				--the new item did not exist in the old bag
				if (bagItemsBefore[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsBefore[k] = v
					output = "BU#" .. GetUnitName("Player") .. "#" .. name .. "#" .. v .. "\r"
					MsendToResearcherLogger(output, "chatAndEvents")
					--self:Print("items equal: " .. output)
				elseif (v ~= bagItemsBefore[k]) then
					local diff = v - bagItemsBefore[k]
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					output = "BU#" .. GetUnitName("Player") .. "#" .. name .. "#" .. diff .. "\r"
					--self:Print("items equal: " .. output)
					MsendToResearcherLogger(output, "chatAndEvents")
				end
			end
			--12/20 Added whole clause below realizing that there might be a swap where an item from bagItemsBefore is replaced (haven't come across an instance of)
			for k,v in pairs(bagItemsBefore) do
				--12/20 had to add the bagItemsAfter[k] clause in case the number of items in each bag is the same but items were switched so that
				--the new item did not exist in the old bag
				if (bagItemsAfter[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsAfter[k] = v
					output = "BU#" .. GetUnitName("Player") .. "#" .. name .. "#-" .. v .. "\r"
					MsendToResearcherLogger(output, "chatAndEvents")
				--self:Print("items equal: " .. output)
				end
			end
		--if bagb4 < bagAfter then added an item, what is that item
		elseif (bagItemsBeforeItemsNo < bagItemsAfterItemsNo) then
			for k,v in pairs(bagItemsAfter) do
				if (bagItemsBefore[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsBefore[k] = v
					output = "BU#" .. GetUnitName("Player") .. "#" .. name .. "#" .. v .. "\r"
					--self:Print("bAfter > bb4: " .. output)
					MsendToResearcherLogger(output, "chatAndEvents")
				end
			end
		--if bagb4 > bagAfter then deleted an item entirely, what is that item
		elseif (bagItemsBeforeItemsNo > bagItemsAfterItemsNo) then

			for k,v in pairs(bagItemsBefore) do
				if (bagItemsAfter[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsBefore[k] = nil
					output = "BU#" .. GetUnitName("Player") .. "#" .. name .. "#" .. "-" .. v .. "\r"
					--self:Print("bAfter < bb4: " .. output)
					MsendToResearcherLogger(output, "chatAndEvents")
				end
			end
		end

		MtableDelete(bagItemsBefore)
		bagItemsBefore = MtableCopy(bagItemsAfter)

	end
end
-- #######################################################

--create a custom function to do/insert something when the secure function is run
function SClogjumps()
	if (MalVars.initializedParticipant == 1) then
		--trace("logged a jump or other upward motion event, including flying or swimming up");
		local output = "JMP#" .. GetUnitName("Player") .. "#" .. "jumped\r";
		sendToResearcherLogger(output);
	end
end

--include this code in the root of Marauder
hooksecurefunc("JumpOrAscendStart", SClogjumps)

